// Template file v5.202 (02/20/02)
////////////////////////////////////////////////////////////////////////
// File: lflare.wdl
//	WDL code for lens flare and lighting effects
//
// 2007 Modified by David Lancaster and Loopix, based on ideas of HeelX
// Lite-C conversion by Alexis Rozhkov aka Shadow
//
// www.loopix-project.com
////////////////////////////////////////////////////////////////////////


//****START LENSFLARE TWEAKABLES****//
var flare_alpha = 70;
var flare_fadespeed = 25; 
//****END LENSFLARE TWEAKABLES****//
////just some vars for the lensflare effect
STRING*	str_skytex = "sky";	// if the first part of the texture scanned matches this, it is sky
//(screen center where pivot_dist = 0) and the sun (pivot_dist = 1).
#define pivot_dist skill99

var lensvisibility = 0;
VECTOR temp2;
VECTOR ctemp;
var qLensFlare = -1;	// -1 == not created
// 0 == off
// 1 == on
// otherwise == turning off
////

////start lensflare setup////
ENTITY* flare1_ent =
{
	type = "lens_01.tga";
	layer = 8;
	view = camera;
	scale_x = 2;
	scale_y = 2;
}

ENTITY* flare2_ent =
{
	type = "lens_02.tga";
	layer = 8;
	view = camera;
	scale_x = 2;
	scale_y = 2;
}

////here would be the sun...at pivot_distance 1

//entity flare3_ent
//{
	//	type = <lens_03.tga>;
	//	layer = 8;
	//	view = CAMERA;
	//	pivot_dist = 1.000;
	//	scale_x = 2;
	//	scale_y = 2;
//}

ENTITY* flare4_ent =
{
	type = "lens_04.tga";
	layer = 8;
	view = camera;
	scale_x = 2;
	scale_y = 2;
}

ENTITY* flare5_ent =
{
	type = "lens_05.tga";
	layer = 8;
	view = camera;
	scale_x = 2;
	scale_y = 2;
}

ENTITY* flare6_ent =
{
	type = "lens_06.tga";
	layer = 8;
	view = camera;
	scale_x = 2;
	scale_y = 2;
}

ENTITY* flare7_ent =
{
	type = "lens_07.tga";
	layer = 8;
	view = camera;
	scale_x = 2;
	scale_y = 2;
}

ENTITY* flare8_ent =
{
	type = "lens_08.tga";
	view = camera;
	layer = 8;
	scale_x = 2;
	scale_y = 2;
}
ENTITY* flare9_ent =
{	// 7 lens reflections
	type = "lens_09.tga";
	view = camera;
	layer = 8;
	scale_x = 2;
	scale_y = 2;
}
ENTITY* flare10_ent =
{
	type = "lens_10.tga";
	view = camera;
	layer = 8;
	scale_x = 2;
	scale_y = 2;
}

ENTITY* flare11_ent =
{
	type = "lens_11.tga";
	layer = 8;
	view = camera;
	scale_x = 2;
	scale_y = 2;
}

ENTITY* flare12_ent =
{
	type = "lens_12.tga";
	layer = 8;
	view = camera;
	scale_x = 2;
	scale_y = 2;
}

ENTITY* flare13_ent =
{
	type = "lens_13.tga";
	layer = 8;
	view = camera;
	scale_x = 2;
	scale_y = 2;
}

ENTITY* flare14_ent =
{
	type = "lens_14.tga";
	layer = 8;
	view = camera;	
	scale_x = 2.5;
	scale_y = 2.5;
}

ENTITY* flare15_ent =
{
	type = "lens_15.tga";
	layer = 8;
	view = camera;
	scale_x = 2;
	scale_y = 2;
}

ENTITY* flare16_ent =
{
	type = "lens_16.tga";
	layer = 8;
	view = camera;
	scale_x = 2;
	scale_y = 2;
}

ENTITY* flare17_ent =
{
	type = "lens_17.tga";
	layer = 8;
	view = camera;
	scale_x = 2;
	scale_y = 2;
}

ENTITY* flare18_ent =
{
	type = "lens_18.tga";
	layer = 8;
	view = camera;
	scale_x = 2;
	scale_y = 2;
}

ENTITY* flare19_ent =
{
	type = "lens_19.tga";
	layer = 8;
	view = camera;
	scale_x = 2;
	scale_y = 2;
}

ENTITY* flare20_ent =
{
	type = "lens_20.tga";
	layer = 8;
	view = camera;
	scale_x = 2.8;
	scale_y = 2.8;
}

void place_lens_startup()
{
	flare1_ent.pivot_dist = 1.278;
	flare2_ent.pivot_dist = 1.200;
//flare3_ent.pivot_dist = 1.000;
   flare4_ent.pivot_dist = 0.522;
	flare5_ent.pivot_dist = 0.434;
	flare6_ent.pivot_dist = 0.348;
	flare7_ent.pivot_dist = 0.306;
	flare8_ent.pivot_dist = 0.262;	
	flare9_ent.pivot_dist = 0.174;
	flare10_ent.pivot_dist = 0.114;
	flare11_ent.pivot_dist = 0.044;
	flare12_ent.pivot_dist = 0.002;
	flare13_ent.pivot_dist = -0.128;
   flare14_ent.pivot_dist = -0.258;
	flare15_ent.pivot_dist = -0.304;
	flare16_ent.pivot_dist = -0.372;
	flare17_ent.pivot_dist = -0.390;
   flare18_ent.pivot_dist = -0.432;
	flare19_ent.pivot_dist = -0.654;
	flare20_ent.pivot_dist = -1.000;
}

////end lensflare setup////


// Desc: this function takes an entity as parameter.
function flare_init(ENTITY* flare_ent)
{
	my = flare_ent;	// necessary because function parameters have no type
	my.flags2 &= ~VISIBLE;
	my.flags |= (BRIGHT|PASSABLE|TRANSLUCENT);
}

// Desc: places a flare at temp.x/temp.y deviations from screen center
function flare_place(ENTITY* flare_ent)
{
	my = flare_ent;
	my.flags2 |= VISIBLE;
	
	camera.pan%=360;//needed to keep the correct sun_angle for lensflare visibility
	
	// multiply the pixel deviation with the pivot factor,
	// and add the screen center
	my.x = ctemp.x*my.pivot_dist + 0.5*screen_size.x;
	my.y = ctemp.y*my.pivot_dist + 0.5*screen_size.y;
	my.z = 1000;	// screen distance, determines the size of the flare
	if(my == flare1_ent)
	{
		vec_set(temp2,sun_pos);
		
		you = player;
		
		
		c_trace(camera.x,temp2.x,IGNORE_ME | IGNORE_YOU | IGNORE_PASSABLE | IGNORE_SPRITES | SCAN_TEXTURE);
		if(trace_hit)
		{
				if(flare1_ent.alpha > 0){
					flare1_ent.alpha -= flare_fadespeed * time_step;
				}
				else{
					flare1_ent.alpha = 0;
				}
		}
		else
		{
			if((camera.pan > sun_angle.pan + 25) || (camera.pan < sun_angle.pan - 25) || (camera.tilt < sun_angle.tilt - 20) || (camera.tilt > sun_angle.tilt + 20))
			{
				if(flare1_ent.alpha > 0){
					flare1_ent.alpha -= flare_fadespeed * time_step;
				}
				else{
					flare1_ent.alpha = 0;
				}
			}
			else{	
				temp2.x = sqrt(abs(((my.x - (0.5*screen_size.x))*(my.x - (0.5*screen_size.x)))+((my.y - (0.5*screen_size.y))*(my.y - (0.5*screen_size.y)))));
				if(abs(temp2.x) > (0.5*screen_size.x))
				{
					flare1_ent.alpha = flare_alpha - (abs(temp2.x) - (0.5*screen_size.x));
					if(flare1_ent.alpha < 0){
						flare1_ent.alpha = 0;
					}
				}
				else{
					if(flare1_ent.alpha < flare_alpha)
					{
						flare1_ent.alpha += flare_fadespeed * time_step;
					}
					else{
						flare1_ent.alpha = flare_alpha;
					}
				}
			}
		}
		
		//		flare1_ent.alpha = (clamp((flare1_ent.alpha-sky_cloud3.alpha),2,100));
		
		if (flare1_ent.alpha < 0) { flare1_ent.alpha = 0;	}
		if (flare1_ent.alpha > flare_alpha) { flare1_ent.alpha = flare_alpha;	}
	}
	rel_for_screen(my.x,camera);
}

// Desc: setup the lens flare effect
function lensflare_create()
{
	// set alpha values for each entity
	flare_init(flare1_ent);
	flare_init(flare2_ent);
	
	//	flare_init(flare3_ent);

	flare_init(flare4_ent);
	flare_init(flare5_ent);
	flare_init(flare6_ent);
	flare_init(flare7_ent);
	flare_init(flare8_ent);
	flare_init(flare9_ent);
	flare_init(flare10_ent);
	flare_init(flare11_ent);
	flare_init(flare12_ent);
	flare_init(flare13_ent);
	flare_init(flare14_ent);
	flare_init(flare15_ent);
	flare_init(flare16_ent);
	flare_init(flare17_ent);
	flare_init(flare18_ent);
	flare_init(flare19_ent);
	flare_init(flare20_ent);

	qLensFlare = 0;	// start 'off'
}

// Desc: start and animate a lens flare effect as long as qLensFlare == 1
//
function	lensflare_start()
{

	if(qLensFlare == -1) // create the lens flares
	{
		lensflare_create();
	}

	if(qLensFlare == 1)  // lens flare already started
	{
		return;
	}

	// allow for setup time for "lensflare_create"
	//(if it was called right before this function)
	wait(1);
	qLensFlare = 1;	// mark lens flare as on

	// place lens flares
	while(1)
	{
		while(qLensFlare == 0.5){ wait(1);}
		
		vec_set(ctemp,sun_pos);
		
		vec_to_screen(ctemp,camera);
		
		ctemp.x -= 0.5 * screen_size.x;
		ctemp.y -= 0.5 * screen_size.y;
		
		flare_place(flare1_ent);
		flare_place(flare2_ent);
		
		//		flare_place(flare3_ent);
		
		flare_place(flare4_ent);
		flare_place(flare5_ent);
		flare_place(flare6_ent);
		flare_place(flare7_ent);
		flare_place(flare8_ent);
		flare_place(flare9_ent);
		flare_place(flare10_ent);
		flare_place(flare11_ent);
		flare_place(flare12_ent);
		flare_place(flare13_ent);
		flare_place(flare14_ent);
		flare_place(flare15_ent);
		flare_place(flare16_ent);
		flare_place(flare17_ent);
		flare_place(flare18_ent);
		flare_place(flare19_ent);
		flare_place(flare20_ent);
		
		flare1_ent.alpha = flare1_ent.alpha - (sky_cloud3.alpha/10);
		flare2_ent.alpha = flare1_ent.alpha;
		
		//		flare3_ent.alpha = flare_alpha;
		
		flare4_ent.alpha = flare1_ent.alpha;
		flare5_ent.alpha = flare1_ent.alpha;
		flare6_ent.alpha = flare1_ent.alpha;
		flare7_ent.alpha = flare1_ent.alpha;
		flare8_ent.alpha = flare1_ent.alpha;
		flare9_ent.alpha = flare1_ent.alpha;
		flare10_ent.alpha = flare1_ent.alpha;
		flare11_ent.alpha = flare1_ent.alpha;
		flare12_ent.alpha = flare1_ent.alpha;
		flare13_ent.alpha = flare1_ent.alpha;
		flare14_ent.alpha = flare1_ent.alpha;
		flare15_ent.alpha = flare1_ent.alpha;
		flare16_ent.alpha = flare1_ent.alpha;
		flare17_ent.alpha = flare1_ent.alpha;
		flare18_ent.alpha = flare1_ent.alpha;
		flare19_ent.alpha = flare1_ent.alpha;
		flare20_ent.alpha = flare1_ent.alpha;
		wait(1);
	}

	// Remove lens flares
	lensvisibility = 0;
	//	flare_visible(off);
	qLensFlare = 0;     // mark lens flare as off
}
