////MystyMood template for setting objects to ground (includs and material LOD and several adjustment possibilities).
////
////Note: This script includes an action "act_obj_SEED_IT" that can be attached to the objects when using SEED_IT from www.gameus.de.
////You will have to assigne the action in the program (SEED_IT) itself. You will also be able to adjust skill1 (wich sets the material
////LOD distance for switching on the alpha-test material for transparent objects).
////When flag1 is set (in SEED_IT), the object will aleways be handeled as solid object (for objects that don't have transparency).
////
////Jun 07 by www.loopix-project.com
////Nov 07 Lite-C conversion by Alexis Rozhkov aka Shadow
////////////////////////////////////////////////////////////////////////////////////////////////

////defines the distance for close objects attributes (wind_movement...)
#define obj_mat_loddist skill1//2000;//material/effect...lod-distance
#define collision_range skill2//0;//distance...enables my.passable = off for collision
#define fade_dist skill3//1000;//fadeout at far distance...when alpha = 0 than invisible
#define fade_speed_fac skill4//1000;//fadeout at far distance...when alpha = 0 than invisible
#define obj_amb_fac skill5//1;//influence of suncolor
#define scale_fac_obj skill6//easy scaling (factor of 1) of object by changing WED skills in the properties panel->bahaviour
#define scale_random_fac skill7//randomness of the scaling
#define z_adjustment skill8//adjusts the z position (height) of the object after it is positioned on the floor
#define pan_angle skill9//adjust the object's pan
#define wind_strenght_fac skill10//influences the objects movement angle width
#define wind_speed_fac skill11//influences the objects movement speed
#define wind_loddist skill12//distance when windmovement is enabled
#define my_push_value skill13//sets the entities push value (my.push = ...)
#define near_cam_fade_dist skill14
#define solid_obj FLAG1//simply check a flag in WED ->properties panel->bahaviour to determine the object-type  (check only one flag!)
#define alphatrans_obj FLAG3//check if the object is...e.g. a plant with alphatransparency
#define always_passable FLAG4//e.g. for grass wich doesen't need collision
#define set_to_floor FLAG5//sets object to floor
#define to_floor_norm FLAG6//check if you want the objects position to adapt the floor steepness
#define random_pan FLAG7//check to set the object with a random pan angle
#define near_cam_transparency FLAG8//fades out obj when camera is close

function init_mat_obj()
{	
	vec_set(mtl.emissive_blue,mat_model.emissive_blue);
	vec_set(mtl.ambient_blue,vector((d3d_fogcolor1.blue/2)+(mat_model.ambient_blue),(d3d_fogcolor1.green/2)+(mat_model.ambient_green),(d3d_fogcolor1.red/2)+(mat_model.ambient_red)));
	vec_set(mtl.diffuse_blue,mat_model.diffuse_blue);
	vec_set(mtl.specular_blue,mat_model.specular_blue);
	mtl.power = 0.3;//mat_model.power;
	mtl.albedo = 200;//mat_model.albedo;   
}


MATERIAL* mat_solid_obj =
{
	event = init_mat_obj;
	
	//	effect = 
	//	"
	//	technique norm
	//	{
		//		pass one
		//		{
			//			cullmode=none;
			//			zenable=true;
			//			zwriteenable=true;
			//			alphablendenable=true;
			//			alphatestenable=false;
		//		}
	//	}
	//	";	
}

MATERIAL* mat_alphatrans_obj =
{

	event = init_mat_obj;

	effect = 
	"
	extern texture entSkin1;

	technique alphaTestMaterial
	{
		//				pass p0{
			//						
			//						zEnable = true;
			//						zWriteEnable=true;
			//						AlphaBlendEnable=false;
			//						alphaTestEnable=true;
			//						AlphaFunc=greater;
			//						AlphaRef=150;///////////////transparency threshold!
			//						cullMode=ccw;
		//				}
		
		
		pass p0
		{
			alphaBlendEnable = false;
			alphaTestEnable = true;
			zWriteEnable = true;
			AlphaRef=140;
		}
		pass p1
		{
			alphaBlendEnable = true;
			alphaTestEnable = false;
			zWriteEnable = false;
			zFunc = less;
		}
	}

	technique fallback
	{
		pass p0{
		Texture[0]=<entSkin1>;}
	}
	";
}


//var d3d_autotransparency = 1;
//var d3d_alpharef = 180;

//sound snd_bullet_rock = <bullet_rock.wav>;
//sound snd_bullet_wood = <bullet_wood.wav>;
//
//function hit_obj() 
//{	
	//	if (event_type == event_impact) 
	//	{
		//		if(you==ent_bullet && (my.flag7 == on || my.flag8 == on)){
			//			
			//			effect(rock_split,1,you.x,nullvector);
			//			
			//			ent_create (bmp_hithole, you.x, display_hithole);
			//			
			//			snd_play(snd_bullet_rock,50,0);
			//			
		//		}
	//	}
//} 


//title:MystyMood Object Template
//image:loopix_logo.pcx
//action:act_object_set 
//skill1:obj_mat_loddist 500.000
//help: distance to switch material (e.g. alphatestmaterial)
//skill2:collision_range 20.000
//help: distance to enable collision
//skill3:fade_dist 1000.000
//help: distance to fade object
//skill4:fade_speed_fac 0.2
//help: speed of object fading 0...1
// section:
//skill5:obj_amb_fac 0.500
//help: ambient intensity of object 0...1
// section:
//skill6:scale_fac_obj 1.000
//help: object scale factor
//skill7:scale_random_fac 0
//help: object random scale factor
// section:
//skill8:z_adjustment 2.000
//help: adjust z(height) position
// section:
//skill9:pan_angle 0
//help: set pan angle of object
// section:
//skill10:wind_strenght_fac 0.000
//help: object movement by wind
//skill11:wind_speed_fac 0.000
//help: object movement-speed by wind
//skill12:wind_loddist 500.000
//help: distance of windmovement start
// section:
//skill13:my_push_value 0
//help: sets the entities push value
// section:
//skill14:near_cam_fade_distance 60
//help: sets distance of camera to obj to start obj fading on close camera
// section:
//text: flag for non-transparent objects
//flag1:solid_obj 0
// section:
//text: flag for transparent object (alphatest material gets applied)
//flag3:alphatrans_obj 0
// section:
//text: flag for setting a constant passable flag
//flag4:always_passable 0
// section:
//text: flag for setting the obj to the floor
//flag5:set_to_floor 0
//text: flag for rotating the object to the floor normals
//flag6:to_floor_norm 0
// section:
//text: sets a random pan angle 0-360
//flag7:random_pan 0
// section:
//text: makes object transparent when close to camera (e.g. for isometric rpg's...)
//flag8:near_cam_transparency 0
//uses: obj_mat_loddist,collision_range,fade_dist,obj_amb_fac,z_adjustment,pan_angle,scale_fac_obj,scale_random_fac,wind_strenght_fac,wind_speed_fac,wind_loddist,solid_obj,alphatrans_obj,set_to_floor,to_floor_norm,random_pan,always_passable,hq_tree_lighting,my_push_value,near_cam_fade_distance
action act_obj_set()
{	
	
	ent_obj = me;
	VECTOR temp;
	
	set(my,TRANSLUCENT);
	my.alpha = 100;
	
	var move_ang_obj[3]; //vector angles 
	var movement_obj; //moving
	
	//set default skills
	if(!my.obj_mat_loddist){my.obj_mat_loddist = 1000;}
	if(!my.collision_range){my.collision_range = 50;}
	if(!my.fade_dist){my.fade_dist = 1000;}
	if(!my.fade_speed_fac){my.fade_speed_fac = 0.2;}
	if(!my.obj_amb_fac){my.obj_amb_fac = 0.5;}
	if(!my.scale_fac_obj){my.scale_fac_obj = 1;}
	if(!my.scale_random_fac){my.scale_random_fac = 0;}
	if(!my.wind_loddist){my.wind_loddist = 800;}
	if(!my.near_cam_fade_dist){my.near_cam_fade_dist = 60;}
	
	//	my.enable_impact = on; // sensible for impact
	//	my.event = hit_obj;
	
	set(my,POLYGON);
	reset(my,PASSABLE);
	
	my.push = my.my_push_value;

	randomize();
	my.skill53 = random (25)+25;
	wait (my.skill53);    
	vec_set (temp, my.x);
	temp.z -= 2000;
	
	if(is(my,set_to_floor)){
		my.z -= c_trace (my.x, temp, IGNORE_ME + IGNORE_YOU + IGNORE_SPRITES + IGNORE_PASSABLE) + my.z_adjustment; // set the correct height (the bottom of the model will sink 10 quants into the soil).
	}
	
	if(is(my,to_floor_norm)){
		vec_to_angle(my.pan,normal); 
		my.tilt-=90;
	}
	
	my.scale_x = my.scale_fac_obj+(random(my.scale_fac_obj*my.scale_random_fac)-random(my.scale_random_fac));
	my.scale_y = my.scale_x;
	my.scale_z = my.scale_x;
	
	if(is(my,random_pan)){
		my.pan = random(359);
	}
	else{
		my.pan = my.pan_angle;
	}
	
	////movement, material lods and fallbacks     
	while (1)
	{
		my.ambient = clamp((-90+sun_angle.tilt*(my.obj_amb_fac*3))+(lightning/3),-100,100);
		
		if(is(my,always_passable)){
			
			reset(my,POLYGON);
			set(my,PASSABLE);
		}
		
		
		if (vec_dist(camera.x,my.x) < my.obj_mat_loddist)
		{
			if(is(my,solid_obj)){
				
				reset(my,TRANSLUCENT);
				my.material = mat_solid_obj;
			}
			
			if(is(my,alphatrans_obj)){
				
				set(my,TRANSLUCENT);
				my.material = mat_alphatrans_obj;
			}
			
		}
		else{
			
			my.material = mat_solid_obj;
		}	
		
		
		if(vec_dist(camera.x,my.x) < my.wind_loddist && !is(ent_terrain,terr_shad_gen)){
			
			movement_obj += (my.wind_speed_fac*4+(random(my.wind_speed_fac*2))*time_step)%360; 
			my.roll= my.roll + ang(my.wind_strenght_fac/8*sin(movement_obj));
			my.tilt= my.tilt + ang(my.wind_strenght_fac/8*cos(movement_obj));
			//c_move (me,nullvector,move_ang_obj,0);
			
		}
		
		if (vec_dist(camera.x,my.x) < my.collision_range && !is(my,always_passable)){
			
			if(is(ent_lake,lake_shore_gen)){
				reset(my,POLYGON);
				set(my,PASSABLE);
			}
			else{
				set(my,POLYGON);
				reset(my,PASSABLE);	 
			}
			
		}
		else
		{
			if(!is(ent_terrain,terr_shad_gen)){
				reset(my,POLYGON);
				set(my,PASSABLE);
			}
			else{
				set(my,POLYGON);
				reset(my,PASSABLE);	
			}
			
		}
		
		my.skill21=vec_dist(my.x,camera.x);
		
		if(my.skill21>my.fade_dist){
			
			reset(my,INVISIBLE);
			
			my.alpha = clamp((-((my.skill21/my.fade_dist)-(my.fade_speed_fac*10)))*100,0,100);
		}
//		else{
//			my.alpha=100;
//		}
		
		if(my.alpha < 1 || camera.z<0){
			
			set(my,INVISIBLE);
		}
		else{
			reset(my,INVISIBLE);
		}
		
		if(is(my,near_cam_transparency))
		{
			if(vec_dist(vector(my.x,my.y,(my.z+((my.max_z-my.min_z)/2))),camera.x) < (my.max_z*1.2)){
				set(my,TRANSLUCENT);
				my.alpha = clamp(my.alpha - 8 * time_step,15,100);
			}
			else{
				set(my,TRANSLUCENT);
				my.alpha = clamp(my.alpha + 8 * time_step,15,100);
			}
		}
		
		wait(1);
	}
}

action act_mat_SEED_IT()
{	
	while (1)
	{
		my.ambient = my.ambient = clamp((-90+sun_angle.tilt*(my.obj_amb_fac*3))+(lightning/3),-100,100);
		
		if (vec_dist(camera.x,my.x) < my.skill1 && !is(my,FLAG1))
		{	
			my.material = mat_alphatrans_obj;
		}	
		else{
			
			my.material = mat_solid_obj;
		}
		if(is(my,FLAG1)){
			
			my.material = mat_solid_obj;
		}
		
		wait(1);		
	}
}

