//////////////////////////////////////////////////////////////////////////////////////////////////////////
////MystyMood river/lake/waterfall template, works with and without shader. Needs A6.5...commercial!
////
////Note: You can change/adjust most values via WED-skills (right mouse-click->properties->behaviour) after 
////you assignd an action to the object (river,lake,waterfall)! Some values (e.g. river/lake rgb texture scales)
////can only be adjusted directly in the ffe/shader part of the sript(water_template.wdl), indicated in caps: 
////"CHANGE THIS TO YOUR NEEDS"  
////
////Jun 07 by loopix-project.com
////Nov 07 Lite-C conversion by Alexis Rozhkov aka Shadow
//////////////////////////////////////////////////////////////////////////////////////////////////////////

function func_rr();

ENTITY* ent_drift_dummy;//not used by default

BMAP* bmp_river_bump = "river_bump.tga";//the greyscale bumpmap for making the waves
BMAP* bmp_river_ffe = "river_diffuse.pcx";//the river rgb texture
BMAP* bmp_river_bump_ffe = "river_bump_ffe.tga";//the grexscale bump texture

BMAP* bmp_lake_bump = "lake_bump.tga";//the greyscale bumpmap for making the waves
BMAP* bmp_lake_ffe = "lake_diffuse.pcx";//the lake rgb texture
BMAP* bmp_lake_bump_ffe = "lake_bump_ffe.tga";//the grexscale bump texture
BMAP* bmp_lake_shoreA = "shoreA.tga";//the shore-break textures
BMAP* bmp_lake_shoreB = "shoreB.tga";

BMAP* canvas_shoremap;
VECTOR canvas_shoremap_size;

STRING* river_hlsl_shoremap_string = "river_hlsl_shoremap.tga";
STRING* river_ffe_shoremap_string = "river_ffe_shoremap.tga";

//STRING* lake_hlsl_shoremap_string = "lake_hlsl_shoremap.tga";
//STRING* lake_ffe_shoremap_string = "lake_ffe_shoremap.tga";

STRING* lake_hlsl_shoremap_tempstr1 = "";
STRING* lake_hlsl_shoremap_tempstr2 = "";
STRING* lake_hlsl_shoremap_str = "lake_hlsl_shoremap_";
STRING* lake_hlsl_shoremap_filetype = ".tga";
STRING* lake_ffe_shoremap_tempstr1 = "";
STRING* lake_ffe_shoremap_tempstr2 = "";
STRING* lake_ffe_shoremap_str = "lake_ffe_shoremap_";
STRING* lake_ffe_shoremap_filetype = ".tga";

//STRING* reflect_cubemap_string = "reflect_cubemap+6.tga";
STRING* reflect_cubemap_tempstr1 = "";
STRING* reflect_cubemap_tempstr2 = "";
STRING* reflect_cubemap_filetype = "+6.tga";
STRING* reflect_cubemap_str = "reflect_cubemap_";

FONT* fnt_arial = "arial#25"; 

STRING*  strg_wait_shore_gen = "Please wait...shoremap-generation is progressing...\n This can take some time...";
STRING*  strg_shore_finished = "Shoremap is now generated and saved to your project folder!";
STRING*  strg_press_shore_gen = "Press 'H' to generate shoremap!";

BMAP* bmp_waterfall =  "waterfall.tga";//the waterfall rgb texture (almost white!)
BMAP* bmp_waterfall_alpha =  "waterfall_alpha.tga";//the waterfall rgb texture (almost white!)
BMAP* bmp_bott_spray = "spray.tga";//waterfall bott particle texture
BMAP* bmp_fall_spray = "fall_spray.tga";//particle-waterfall sprite


//settings for the river models
#define riv_add_red skill1
#define riv_add_green skill2
#define riv_add_blue skill3
#define riv_fogcol_fac skill4
#define riv_alpha  skill5

#define riv_wav_speed_x skill6//0.0
#define riv_wav_speed_y skill7//-0.13
#define riv_wav_scale skill8//0.6
#define riv_wav_height skill9//0.5

#define riv_geowave_amp skill10
#define riv_geowave_sp skill11
#define riv_geowavemove FLAG1

#define riv_id_number skill12

#define riv_ffe_only FLAG3

#define riv_enable_rr FLAG4

var water_vertex_array [10000];//allows a waterplane of max 100x100 vertices for the "geowavemove" (geometrical movement of the water entities)



//for use with a player reacting to the river drift forces
#define player_abs_dist_force skill50//just a skill to save the player_abs_dist_force
//settings for the drift_dummy models (triangles)
#define drift_force skill1//for rivers and streams
#define no_drift_force FLAG1//set this flag for still waters


#define lake_add_red skill1//0-255, adds a specific color tint
#define lake_add_green skill2//0-255
#define lake_add_blue skill3//0-255
#define lake_fogcol_fac skill4//0-1, factor of the fogcolor diffuse influence (NOTE:fogcol_spec_fac has much more influence)
#define lake_alpha  skill5//water transparency

#define lake_wav_speed_x skill6//0.02
#define lake_wav_speed_y skill7//-0.04
#define lake_wav_scale skill8//20
#define lake_wav_height skill9//0.6

#define lake_shore_depth  skill10
#define lake_shore_smoothness skill11
#define lake_shore_gen FLAG3

#define lake_geowave_amp skill2
#define lake_geowave_sp skill13

#define lake_id_number skill14

#define lake_geowavemove FLAG1

#define lake_ffe_only FLAG4

#define lake_enable_rr FLAG5

#define particle_fall  FLAG1//paticle_fall (set flag) or model_fall (no flag)?
#define fall_add_red  skill1
#define fall_add_green  skill2
#define fall_add_blue  skill3
#define fall_fogcol_fac  skill4
#define fall_alpha  skill5
#define fall_speed_y skill6//6.0
#define fall_scale_x  skill7//1
#define fall_scale_z  skill8//1

#define bott_spray_alpha  skill9//60
#define bott_spray_speed  skill10
#define bott_spray_fadetime  skill11//6
#define bott_spray_dens  skill12
#define bott_spray_bright  FLAG3

#define p_fall_jet_force  skill13
#define p_fall_dens  skill14
#define p_fall_fadetime  skill15

#define fall_bright  FLAG4

TEXT* txt_wait_shore_gen =
{
	font = fnt_arial;
	layer = 10;
	flags = center_x,center_y,outline;
	string = strg_wait_shore_gen;
	red = 255;
	green = 0;
	blue = 0;
}

TEXT* txt_shore_finished =
{
	font = fnt_arial;
	layer = 10;
	flags = center_x,center_y,outline;
	string = strg_shore_finished;
	red = 0;
	green = 255;
	blue = 0;
}

TEXT* txt_press_shore_gen =
{
	font = fnt_arial;
	layer = 10;
	flags = center_x,center_y,outline;
	string = strg_press_shore_gen;
	red = 0;
	green = 0;
	blue = 255;
}



function init_mat_hlsl_river()
{
	bmap_to_mipmap(mtl.skin1);
	bmap_to_normals(mtl.skin1,1);
	bmap_to_cubemap(mtl.skin2);
	
	mtl.skill1 = pixel_for_vec(vector(clamp((d3d_fogcolor1.blue*my.riv_fogcol_fac)+(my.riv_add_blue*clamp(sun_angle.tilt/30,0.2,1))+(lightning),0,255),clamp((d3d_fogcolor1.green*my.riv_fogcol_fac)+(my.riv_add_green*clamp(sun_angle.tilt/30,0.2,1))+(lightning),0,255),clamp((d3d_fogcolor1.red*my.riv_fogcol_fac)+(my.riv_add_red*clamp(sun_angle.tilt/30,0.2,1))+(lightning),0,255)),100,8888);
	mtl.skill2 = pixel_for_vec(nullvector,my.riv_alpha,8888);
	mtl.skill3 = pixel_for_vec(d3d_fogcolor1.blue,clamp(d3d_fogcolor1.blue,0,100),8888);
	
	
	set(mtl,ENABLE_RENDER);
}

MATERIAL* mat_hlsl_river =
{
	flags = tangent;

	skin1 = bmp_river_bump;
	
	skin3 = bmp_lake_shoreA;
	skin4 = bmp_lake_shoreB;

	event = init_mat_hlsl_river;

	effect=
	"
	float4x4 matWorldViewProj;
	float4x4 matWorld;
	float4x4 matWorldInv;
	float4x4 matViewInv;
	
	float4 vecFog;
	float4 vecTime;
	float4 vecSkill41; // Wind_X, Wind_Y, Ripple, Scale
	float4 vecColor;
	
	float4 mtlSkill1;
	float4 mtlSkill2;
	float4 mtlSkill3;
	
	#define ShoreScale 50
	#define ShoreBewegung 100
	#define ShoreSpeed 0.05
	
	texture entSkin1;
	texture mtlSkin1;
	texture mtlSkin2;
	texture mtlSkin3;
	texture mtlSkin4;

	//////////////////////////////////////////////////////////////////////
	//section: transform - calculate vertex position /////////////////////
	
	float4 DoTransform(float4 Pos)
	{
		return mul(Pos,matWorldViewProj);
	}


	//////////////////////////////////////////////////////////////////////
	//section: fog ///////////////////////////////////////////////////////
	
	float4 vecViewPos;
	float DoFog(float4 Pos)
	{
		float3 P = mul(Pos,matWorld);
		return 1 - (distance(P,vecViewPos)-vecFog.x) * vecFog.z;
	}


	//////////////////////////////////////////////////////////////////////
	//section: pos - transform vertex position to world space ////////////
	
	float4 DoPos(float4 Pos)
	{
		return (mul(Pos,matWorld));
	}
	float3 DoPos(float3 Pos)
	{
		return (mul(Pos,matWorld));
	}


	//////////////////////////////////////////////////////////////////////
	//section: normal - transform vertex normal //////////////////////////
	
	float3 DoNormal(float3 inNormal)
	{
		return normalize(mul(inNormal,matWorld));
	}

	sampler sBumpTex = sampler_state { Texture = (mtlSkin1); };
	sampler sCubeTex = sampler_state { Texture = (mtlSkin2); };
	sampler sAlphaTex = sampler_state { Texture = (entSkin1); };
	
	sampler sShoreATex = sampler_state { Texture = (mtlSkin3); };
	sampler sShoreBTex = sampler_state { Texture = (mtlSkin4); };

	struct out_water_env // Output to the pixelshader
	{
		float4 Pos	: POSITION;
		float4 Color: COLOR0;
		float  Fog	: FOG;
		float2 Tex0	: TEXCOORD0;
		float4 TanToCube0:	TEXCOORD1;
		float4 TanToCube1:	TEXCOORD2;
		float4 TanToCube2:	TEXCOORD3;
		float2 Tex1:	TEXCOORD4;
		float3 eyePos:	TEXCOORD5;
		
		float2 Tex2 	: TEXCOORD6;
		float2 Tex3		: TEXCOORD7;
	};

	out_water_env vs_water_env
	(
	float4 inPos		: POSITION,
	float3 inNormal	: NORMAL,
	float2 inTex0	: TEXCOORD0,
	float3 inTangent	: TEXCOORD2
	)
	{
		out_water_env Out;
		
		Out.Pos = DoTransform(inPos); // transform to screen coordinates
		Out.Fog = DoFog(inPos);
		
		// bump and reflection coordinates
		Out.Tex0 = (inTex0 + vecSkill41.xy * vecTime.w) * vecSkill41.w;
		Out.Tex1 = inTex0;
		
		Out.Tex2 = (inTex0 + vecSkill41.xy * sin(vecTime.w*ShoreSpeed)*ShoreBewegung) * ShoreScale;//moving the shore texture	
		Out.Tex3 = (inTex0 + vecSkill41.xy * cos(vecTime.w*ShoreSpeed)*ShoreBewegung) * ShoreScale;//moving the shore texture
		
		float3x3 ObjToTan;
		
		ObjToTan[0] = vecSkill41.z * inTangent;
		ObjToTan[1] = vecSkill41.z * cross(inTangent, inNormal);
		ObjToTan[2] = inNormal;
		
		Out.TanToCube0.xyz = mul(ObjToTan,matWorld[0].xyz);
		Out.TanToCube1.xyz = mul(ObjToTan,matWorld[1].xyz);
		Out.TanToCube2.xyz = mul(ObjToTan,matWorld[2].xyz);
		
		float4 P = DoPos(inPos); // vector world position
		float4 vecToView = normalize(vecViewPos-P); // direction towards camera
		
		Out.TanToCube0.w = vecToView.x;
		Out.TanToCube1.w = vecToView.y;
		Out.TanToCube2.w = vecToView.z;
		
		// color and transparency
		
		Out.Color = vecColor;
		
		float3 N = DoNormal(inNormal); // normal world orientation
		Out.Color = (0.6 + (vecColor.a * mtlSkill2) * (1.0 - dot(vecToView,N)))*mtlSkill1;

		
		float4 worldPos = mul(inPos, matWorld);
		Out.eyePos = matViewInv[3] - worldPos;
		
		return Out;
	}

	float4 PS_p0(	float4 VertColor: COLOR0, float2 texCoord: TEXCOORD0,
	float3 TanCube0: TEXCOORD1, float3 TanCube1: TEXCOORD2,
	float3 TanCube2: TEXCOORD3, float2 Tex1: TEXCOORD4, float3 eyePos : TEXCOORD5,
	float2 ShoreATex : TEXCOORD6, float2 ShoreBTex : TEXCOORD7
	) : COLOR 
	{
		//Read ShoreMapPixel
		float4 ShoreMapColor = tex2D(sAlphaTex,Tex1);
		
		// die Bumpmap mit der waterCoord Koordinaten
		float4 bump = tex2D(sBumpTex, texCoord) * 2 - 1;
		
		half3 N = bump.xyz;
		
		half3x3 m; // tangent to world matrix
		
		m[0] = TanCube0;
		m[1] = TanCube1;
		m[2] = TanCube2;
		
		half3 Nw = mul(m, N.xyz);
		Nw = normalize(Nw);
		
		// reflection
		float3 E = normalize(eyePos);
		half3 R = reflect(-E, Nw);
		
		// Reflektierte Wasseroberflche
		float4 reflection = texCUBE(sCubeTex, R);
		
		reflection *= VertColor;
		
		if(ShoreMapColor.r > 0)
		{
			//Shoreline
			float4 ShoreColor;
			float4 ShoreAColor = tex2D(sShoreATex,ShoreATex);
			float4 ShoreBColor = tex2D(sShoreBTex,ShoreBTex);
			ShoreColor = (ShoreAColor+ShoreBColor-1)*(mtlSkill3+0.3);
			
			reflection = lerp(reflection,ShoreColor,ShoreMapColor.r);
			
		}
		
		reflection.a *= 1-ShoreMapColor.g;
		
		// Output
		return reflection;
	}


	//////////////////////////////////////////////////////////////////

	technique water_env
	{
		pass one
		{
			alphablendenable = true;
			alphatestenable = false;
			zenable = true;
			zwriteenable=true;
			
			cullmode = none;
			
			VertexShader = compile vs_1_1 vs_water_env();
			PixelShader = compile ps_2_0 PS_p0();
		}
	}

technique fallback { pass one { } }";
}

function init_mat_hlsl_river_rr()
{
	bmap_to_mipmap(mtl.skin1);
	bmap_to_normals(mtl.skin1,1);
	
	mtl.skill1 = pixel_for_vec(vector(clamp((d3d_fogcolor1.blue*my.riv_fogcol_fac)+(my.riv_add_blue*clamp(sun_angle.tilt/30,0.2,1))+(lightning),0,255),clamp((d3d_fogcolor1.green*my.riv_fogcol_fac)+(my.riv_add_green*clamp(sun_angle.tilt/30,0.2,1))+(lightning),0,255),clamp((d3d_fogcolor1.red*my.riv_fogcol_fac)+(my.riv_add_red*clamp(sun_angle.tilt/30,0.2,1))+(lightning),0,255)),100,8888);	
	mtl.skill2 = pixel_for_vec(nullvector,my.riv_alpha,8888);	
	mtl.skill3 = pixel_for_vec(vector(200*clamp(sun_angle.tilt/30,0,1),200*clamp(sun_angle.tilt/30,0,1),200*clamp(sun_angle.tilt/30,0,1)),100,8888);
	
	set(mtl,ENABLE_RENDER);
}

MATERIAL* mat_hlsl_river_rr =
{
	flags = tangent;

	skin1 = bmp_river_bump;
	
	skin3 = bmp_lake_shoreA;
	skin4 = bmp_lake_shoreB;

	event = init_mat_hlsl_river_rr;

	effect=
	"
	float4x4 matWorld;
	float4x4 matViewInv;
	float4x4 matWorldViewProj;
	
	float4 vecFog;
	float4 vecViewPos;
	float4 vecTime;
	
	float4 vecColor;
	float4 vecSkill41; // Wind_X, Wind_Y, Ripple, Scale
	float4 mtlSkill1;
	float4 mtlSkill2;
	float4 mtlSkill3;
	
	#define ShoreScale 100
	#define ShoreBewegung 50
	#define ShoreSpeed 0.03
	
	texture entSkin1;
	texture mtlSkin1;
	texture mtlSkin2;
	texture mtlSkin3;
	texture mtlSkin4;

	sampler sBumpTex = sampler_state { Texture = (mtlSkin1); };
	sampler sReflectTex = sampler_state
	{
		Texture = (mtlSkin2);
		AddressU = Clamp;
		AddressV = Clamp;
	};
	sampler sAlphaTex = sampler_state { Texture = (entSkin1); };
	
	sampler sShoreATex = sampler_state { Texture = (mtlSkin3); };
	sampler sShoreBTex = sampler_state { Texture = (mtlSkin4); };
	
	
	//////////////////////////////////////////////////////////////////////
	//section: transform - calculate vertex position /////////////////////
	
	float4 DoTransform(float4 Pos)
	{
		return mul(Pos,matWorldViewProj);
	}


	//////////////////////////////////////////////////////////////////////
	//section: fog ///////////////////////////////////////////////////////
	
	float DoFog(float4 Pos)
	{
		float3 P = mul(Pos,matWorld);
		return 1 - (distance(P,vecViewPos)-vecFog.x) * vecFog.z;
	}

	//////////////////////////////////////////////////////////////////////
	//section: pos - transform vertex position to world space ////////////
	
	float4 DoPos(float4 Pos)
	{
		return (mul(Pos,matWorld));
	}
	float3 DoPos(float3 Pos)
	{
		return (mul(Pos,matWorld));
	}


	//////////////////////////////////////////////////////////////////////
	//section: normal - transform vertex normal //////////////////////////
	
	float3 DoNormal(float3 inNormal)
	{
		return normalize(mul(inNormal,matWorld));
	}
	
	
	
	struct out_water_env // Output to the pixelshader
	{
		float4 Pos	: POSITION;
		float4 Color: COLOR0;
		float  Fog	: FOG;
		
		float2 Tex0	: TEXCOORD0;	//Bumpmap
		float2 Tex1 : TEXCOORD1;	//Shoremap
		float2 Tex2 : TEXCOORD2;	//Shore 1
		float2 Tex3	: TEXCOORD3;	//Shore 2
		float3 Tex4	: TEXCOORD4;	//Reflection
	};

	out_water_env vs_water_env
	(
	float4 inPos		: POSITION,
	float3 inNormal	: NORMAL,
	float2 inTex0	: TEXCOORD0
	)
	{
		out_water_env Out;
		
		Out.Pos = DoTransform(inPos); // transform to screen coordinates
		Out.Fog = DoFog(inPos);
		
		// bump and reflection coordinates
		Out.Tex0 = (inTex0 + vecSkill41.xy * vecTime.w) * vecSkill41.w;
		Out.Tex1 = inTex0;
		//		Out.Tex1 = (inTex0 + vecSkill41.xy * sin(vecTime.w*ShoreSpeed*2)*ShoreBewegung);//slightly moving the shore-blendmap
		
		Out.Tex2 = (inTex0 + vecSkill41.xy * sin(vecTime.w*ShoreSpeed)*ShoreBewegung) * ShoreScale;//moving the shore texture	
		Out.Tex3 = (inTex0 + vecSkill41.xy * cos(vecTime.w*ShoreSpeed)*ShoreBewegung) * ShoreScale;//moving the shore texture
		
		Out.Tex4 = Out.Pos.xyw;
		
		// color and transparency
		Out.Color = vecColor;
		
		//Fresnel
		float4 P = DoPos(inPos); // vector world position
		float4 vecToView = normalize(vecViewPos-P); // direction towards camera
		float3 N = DoNormal(inNormal); // normal world orientation
		Out.Color = (0.6 + (vecColor.a * mtlSkill2) * (1.0 - dot(vecToView,N)))*mtlSkill1;
		
		return Out;
	}

	float4 PS_p0(	float4 VertColor: COLOR0, float2 texCoord: TEXCOORD0,
	float2 Tex1: TEXCOORD1, float2 ShoreATex : TEXCOORD2,
	float2 ShoreBTex : TEXCOORD3, float3 Tex4	: TEXCOORD4
	) : COLOR 
	{
		//Read ShoreMapPixel
		float4 ShoreMapColor = tex2D(sAlphaTex,Tex1);
		
		// die Bumpmap mit der waterCoord Koordinaten
		float4 Bump = tex2D(sBumpTex, texCoord) * 2 - 1;
		
		float2 temp = Tex4.xy/Tex4.z;
		float2 Coord = 0.5*(1.0+temp)+Bump.xy*vecSkill41.z;
		
		// Reflektierte Wasseroberflche
		float4 reflection = tex2D(sReflectTex, Coord);
		reflection.a = 1;
		
		reflection *= VertColor;
		
		if(ShoreMapColor.r > 0)
		{
			//Shoreline
			float4 ShoreColor;
			float4 ShoreAColor = tex2D(sShoreATex,ShoreATex);
			float4 ShoreBColor = tex2D(sShoreBTex,ShoreBTex);
			
			ShoreColor = (ShoreAColor+ShoreBColor-1)*(mtlSkill3+0.3);
			
			reflection = lerp(reflection,ShoreColor,ShoreMapColor.r);
		}
		
		reflection.a *= (1-ShoreMapColor.g);
		
		// Output
		return reflection;
	}


	//////////////////////////////////////////////////////////////////

	technique water_env
	{
		pass one
		{
			alphablendenable = true;
			alphatestenable = false;//true;
			zenable = true;
			zwriteenable=true;
			
			CullMode=none;
			
			VertexShader = compile vs_1_1 vs_water_env();
			PixelShader = compile ps_2_0 PS_p0();
		}
	}

technique fallback { pass one { } }";
}




function init_mat_hlsl_lake()
{
	bmap_to_mipmap(mtl.skin1);
	bmap_to_normals(mtl.skin1,1);
	bmap_to_cubemap(mtl.skin2);
	
	mtl.skill1 = pixel_for_vec(vector(clamp((d3d_fogcolor1.blue*my.lake_fogcol_fac)+(my.lake_add_blue*clamp(sun_angle.tilt/30,0.2,1))+(lightning),0,255),clamp((d3d_fogcolor1.green*my.lake_fogcol_fac)+(my.lake_add_green*clamp(sun_angle.tilt/30,0.2,1))+(lightning),0,255),clamp((d3d_fogcolor1.red*my.lake_fogcol_fac)+(my.lake_add_red*clamp(sun_angle.tilt/30,0.2,1))+(lightning),0,255)),100,8888);	
	mtl.skill2 = pixel_for_vec(nullvector,my.lake_alpha,8888);	
	mtl.skill3 = pixel_for_vec(vector(200*clamp(sun_angle.tilt/30,0,1),200*clamp(sun_angle.tilt/30,0,1),200*clamp(sun_angle.tilt/30,0,1)),100,8888);
	
	set(mtl,ENABLE_RENDER);
}

MATERIAL* mat_hlsl_lake =
{
	flags = tangent;

	skin1 = bmp_lake_bump;
	
	skin3 = bmp_lake_shoreA;
	skin4 = bmp_lake_shoreB;

	event = init_mat_hlsl_lake;

	effect=
	"
	float4x4 matWorldViewProj;
	float4x4 matWorld;
	float4x4 matWorldInv;
	float4x4 matViewInv;
	
	float4 vecFog;
	float4 vecTime;
	float4 vecSkill41; // Wind_X, Wind_Y, Ripple, Scale
	float4 vecColor;
	
	float4 mtlSkill1;
	float4 mtlSkill2;
	float4 mtlSkill3;
	
	#define ShoreScale 50
	#define ShoreBewegung 100
	#define ShoreSpeed 0.05
	
	texture entSkin1;
	texture mtlSkin1;
	texture mtlSkin2;
	texture mtlSkin3;
	texture mtlSkin4;

	//////////////////////////////////////////////////////////////////////
	//section: transform - calculate vertex position /////////////////////
	
	float4 DoTransform(float4 Pos)
	{
		return mul(Pos,matWorldViewProj);
	}


	//////////////////////////////////////////////////////////////////////
	//section: fog ///////////////////////////////////////////////////////
	
	float4 vecViewPos;
	float DoFog(float4 Pos)
	{
		float3 P = mul(Pos,matWorld);
		return 1 - (distance(P,vecViewPos)-vecFog.x) * vecFog.z;
	}


	//////////////////////////////////////////////////////////////////////
	//section: pos - transform vertex position to world space ////////////
	
	float4 DoPos(float4 Pos)
	{
		return (mul(Pos,matWorld));
	}
	float3 DoPos(float3 Pos)
	{
		return (mul(Pos,matWorld));
	}


	//////////////////////////////////////////////////////////////////////
	//section: normal - transform vertex normal //////////////////////////
	
	float3 DoNormal(float3 inNormal)
	{
		return normalize(mul(inNormal,matWorld));
	}


	sampler sBumpTex = sampler_state { Texture = (mtlSkin1); };
	sampler sCubeTex = sampler_state { Texture = (mtlSkin2); };
	sampler sAlphaTex = sampler_state { Texture = (entSkin1); };
	
	sampler sShoreATex = sampler_state { Texture = (mtlSkin3); };
	sampler sShoreBTex = sampler_state { Texture = (mtlSkin4); };

	struct out_water_env // Output to the pixelshader
	{
		float4 Pos	: POSITION;
		float4 Color: COLOR0;
		float  Fog	: FOG;
		float2 Tex0	: TEXCOORD0;
		float4 TanToCube0:	TEXCOORD1;
		float4 TanToCube1:	TEXCOORD2;
		float4 TanToCube2:	TEXCOORD3;
		float2 Tex1:	TEXCOORD4;
		float3 eyePos:	TEXCOORD5;
		
		float2 Tex2 	: TEXCOORD6;
		float2 Tex3		: TEXCOORD7;
	};

	out_water_env vs_water_env
	(
	float4 inPos		: POSITION,
	float3 inNormal	: NORMAL,
	float2 inTex0	: TEXCOORD0,
	float3 inTangent	: TEXCOORD2
	)
	{
		out_water_env Out;
		
		Out.Pos = DoTransform(inPos); // transform to screen coordinates
		Out.Fog = DoFog(inPos);
		
		// bump and reflection coordinates
		Out.Tex0 = (inTex0 + vecSkill41.xy * vecTime.w) * vecSkill41.w;
		Out.Tex1 = inTex0;
		
		Out.Tex2 = (inTex0 + vecSkill41.xy * sin(vecTime.w*ShoreSpeed)*ShoreBewegung) * ShoreScale;//moving the shore texture	
		Out.Tex3 = (inTex0 + vecSkill41.xy * cos(vecTime.w*ShoreSpeed)*ShoreBewegung) * ShoreScale;//moving the shore texture
		
		float3x3 ObjToTan;
		
		ObjToTan[0] = vecSkill41.z * inTangent;
		ObjToTan[1] = vecSkill41.z * cross(inTangent, inNormal);
		ObjToTan[2] = inNormal;
		
		Out.TanToCube0.xyz = mul(ObjToTan,matWorld[0].xyz);
		Out.TanToCube1.xyz = mul(ObjToTan,matWorld[1].xyz);
		Out.TanToCube2.xyz = mul(ObjToTan,matWorld[2].xyz);
		
		float4 P = DoPos(inPos); // vector world position
		float4 vecToView = normalize(vecViewPos-P); // direction towards camera
		
		Out.TanToCube0.w = vecToView.x;
		Out.TanToCube1.w = vecToView.y;
		Out.TanToCube2.w = vecToView.z;
		
		// color and transparency
		
		Out.Color = vecColor;
		
		float3 N = DoNormal(inNormal); // normal world orientation
		Out.Color = (0.6 + (vecColor.a * mtlSkill2) * (1.0 - dot(vecToView,N)))*mtlSkill1;
		
		float4 worldPos = mul(inPos, matWorld);
		Out.eyePos = matViewInv[3] - worldPos;
		
		return Out;
	}

	float4 PS_p0(	float4 VertColor: COLOR0, float2 texCoord: TEXCOORD0,
	float3 TanCube0: TEXCOORD1, float3 TanCube1: TEXCOORD2,
	float3 TanCube2: TEXCOORD3, float2 Tex1: TEXCOORD4, float3 eyePos : TEXCOORD5,
	float2 ShoreATex : TEXCOORD6, float2 ShoreBTex : TEXCOORD7
	) : COLOR 
	{
		//Read ShoreMapPixel
		float4 ShoreMapColor = tex2D(sAlphaTex,Tex1);
		
		// die Bumpmap mit der waterCoord Koordinaten
		float4 bump = tex2D(sBumpTex, texCoord) * 2 - 1;

		half3 N = bump.xyz;
		
		half3x3 m; // tangent to world matrix

		m[0] = TanCube0;
		m[1] = TanCube1;
		m[2] = TanCube2;
		
		half3 Nw = mul(m, N.xyz);
		Nw = normalize(Nw);

		// reflection
		float3 E = normalize(eyePos);
		half3 R = reflect(-E, Nw);

		// Reflektierte Wasseroberflche
		float4 reflection = texCUBE(sCubeTex, R);
		
		reflection *= VertColor;
		
		if(ShoreMapColor.r > 0)
		{
			//Shoreline
			float4 ShoreColor;
			float4 ShoreAColor = tex2D(sShoreATex,ShoreATex);
			float4 ShoreBColor = tex2D(sShoreBTex,ShoreBTex);
			ShoreColor = (ShoreAColor+ShoreBColor-1)*(mtlSkill3+0.3);
			
			reflection = lerp(reflection,(ShoreColor),ShoreMapColor.r);
			
		}
		
		reflection.a *= 1-ShoreMapColor.g;
		
		// Output
		return reflection;
	}


	//////////////////////////////////////////////////////////////////

	technique water_env
	{
		pass one
		{
			alphablendenable = true;
			alphatestenable = false;//true;
			zenable = true;
			zwriteenable=true;
			
			CullMode=none;
			
			VertexShader = compile vs_1_1 vs_water_env();
			PixelShader = compile ps_2_0 PS_p0();
		}
	}

technique fallback { pass one { } }";
}


function init_mat_hlsl_lake_rr()
{
	bmap_to_mipmap(mtl.skin1);
	bmap_to_normals(mtl.skin1,1);
	
	mtl.skill1 = pixel_for_vec(vector(clamp((d3d_fogcolor1.blue*my.lake_fogcol_fac)+(my.lake_add_blue*clamp(sun_angle.tilt/30,0.2,1))+(lightning),0,255),clamp((d3d_fogcolor1.green*my.lake_fogcol_fac)+(my.lake_add_green*clamp(sun_angle.tilt/30,0.2,1))+(lightning),0,255),clamp((d3d_fogcolor1.red*my.lake_fogcol_fac)+(my.lake_add_red*clamp(sun_angle.tilt/30,0.2,1))+(lightning),0,255)),100,8888);	
	mtl.skill2 = pixel_for_vec(nullvector,my.lake_alpha,8888);	
	mtl.skill3 = pixel_for_vec(vector(200*clamp(sun_angle.tilt/30,0,1),200*clamp(sun_angle.tilt/30,0,1),200*clamp(sun_angle.tilt/30,0,1)),100,8888);
	
	set(mtl,ENABLE_RENDER);
}

MATERIAL* mat_hlsl_lake_rr =
{
	flags = tangent;

	skin1 = bmp_lake_bump;
	
	skin3 = bmp_lake_shoreA;
	skin4 = bmp_lake_shoreB;

	event = init_mat_hlsl_lake_rr;

	effect=
	"
	float4x4 matWorld;
	float4x4 matViewInv;
	float4x4 matWorldViewProj;
	
	float4 vecFog;
	float4 vecViewPos;
	float4 vecTime;
	
	float4 vecColor;
	float4 vecSkill41; // Wind_X, Wind_Y, Ripple, Scale
	
	float4 mtlSkill1;
	float4 mtlSkill2;
	float4 mtlSkill3;
	
	#define ShoreScale 100
	#define ShoreBewegung 50
	#define ShoreSpeed 0.03
	
	texture entSkin1;
	texture mtlSkin1;
	texture mtlSkin2;
	texture mtlSkin3;
	texture mtlSkin4;

	sampler sBumpTex = sampler_state { Texture = (mtlSkin1); };
	sampler sReflectTex = sampler_state
	{
		Texture = (mtlSkin2);
		AddressU = Clamp;
		AddressV = Clamp;
	};
	sampler sAlphaTex = sampler_state { Texture = (entSkin1); };
	
	sampler sShoreATex = sampler_state { Texture = (mtlSkin3); };
	sampler sShoreBTex = sampler_state { Texture = (mtlSkin4); };
	
	
	//////////////////////////////////////////////////////////////////////
	//section: transform - calculate vertex position /////////////////////
	
	float4 DoTransform(float4 Pos)
	{
		return mul(Pos,matWorldViewProj);
	}


	//////////////////////////////////////////////////////////////////////
	//section: fog ///////////////////////////////////////////////////////
	
	float DoFog(float4 Pos)
	{
		float3 P = mul(Pos,matWorld);
		return 1 - (distance(P,vecViewPos)-vecFog.x) * vecFog.z;
	}



	//////////////////////////////////////////////////////////////////////
	//section: pos - transform vertex position to world space ////////////
	
	float4 DoPos(float4 Pos)
	{
		return (mul(Pos,matWorld));
	}
	float3 DoPos(float3 Pos)
	{
		return (mul(Pos,matWorld));
	}


	//////////////////////////////////////////////////////////////////////
	//section: normal - transform vertex normal //////////////////////////
	
	float3 DoNormal(float3 inNormal)
	{
		return normalize(mul(inNormal,matWorld));
	}
	
	
	struct out_water_env // Output to the pixelshader
	{
		float4 Pos	: POSITION;
		float4 Color: COLOR0;
		float  Fog	: FOG;
		
		float2 Tex0	: TEXCOORD0;	//Bumpmap
		float2 Tex1 : TEXCOORD1;	//Shoremap
		float2 Tex2 : TEXCOORD2;	//Shore 1
		float2 Tex3	: TEXCOORD3;	//Shore 2
		float3 Tex4	: TEXCOORD4;	//Reflection
	};

	out_water_env vs_water_env
	(
	float4 inPos		: POSITION,
	float3 inNormal	: NORMAL,
	float2 inTex0	: TEXCOORD0
	)
	{
		out_water_env Out;
		
		Out.Pos = DoTransform(inPos); // transform to screen coordinates
		Out.Fog = DoFog(inPos);
		
		// bump and reflection coordinates
		Out.Tex0 = (inTex0 + vecSkill41.xy * vecTime.w) * vecSkill41.w;
		//		Out.Tex1 = inTex0;
		Out.Tex1 = (inTex0 + vecSkill41.xy * sin(vecTime.w*ShoreSpeed*2)*ShoreBewegung);//moving the shore texture
		
		Out.Tex2 = (inTex0 + vecSkill41.xy * sin(vecTime.w*ShoreSpeed)*ShoreBewegung) * ShoreScale;//moving the shore texture	
		Out.Tex3 = (inTex0 + vecSkill41.xy * cos(vecTime.w*ShoreSpeed)*ShoreBewegung) * ShoreScale;//moving the shore texture
		
		Out.Tex4 = Out.Pos.xyw;
		
		// color and transparency
		Out.Color = vecColor;
		
		//Fresnel
		float4 P = DoPos(inPos); // vector world position
		float4 vecToView = normalize(vecViewPos-P); // direction towards camera
		float3 N = DoNormal(inNormal); // normal world orientation
		Out.Color = (0.6 + (vecColor.a * mtlSkill2) * (1.0 - dot(vecToView,N)))*mtlSkill1;
		
		return Out;
	}

	float4 PS_p0(	float4 VertColor: COLOR0, float2 texCoord: TEXCOORD0,
	float2 Tex1: TEXCOORD1, float2 ShoreATex : TEXCOORD2,
	float2 ShoreBTex : TEXCOORD3, float3 Tex4	: TEXCOORD4
	) : COLOR 
	{
		//Read ShoreMapPixel
		float4 ShoreMapColor = tex2D(sAlphaTex,Tex1);
		
		// die Bumpmap mit der waterCoord Koordinaten
		float4 Bump = tex2D(sBumpTex, texCoord) * 2 - 1;
		
		float2 temp = Tex4.xy/Tex4.z;
		float2 Coord = 0.5*(1.0+temp)+Bump.xy*vecSkill41.z;
		
		// Reflektierte Wasseroberflche
		float4 reflection = tex2D(sReflectTex, Coord);
		reflection.a = 1;
		
		reflection *= VertColor;
		
		if(ShoreMapColor.r > 0)
		{
			//Shoreline
			float4 ShoreColor;
			float4 ShoreAColor = tex2D(sShoreATex,ShoreATex);
			float4 ShoreBColor = tex2D(sShoreBTex,ShoreBTex);
			
			ShoreColor = (ShoreAColor+ShoreBColor-1)*(mtlSkill3+0.3);
			
			reflection = lerp(reflection,ShoreColor,ShoreMapColor.r);
		}
		
		reflection.a *= (1-ShoreMapColor.g);
		
		// Output
		return reflection;
	}


	//////////////////////////////////////////////////////////////////

	technique water_env
	{
		pass one
		{
			alphablendenable = true;
			alphatestenable = false;//true;
			zenable = true;
			zwriteenable=true;
			
			CullMode=none;
			
			VertexShader = compile vs_1_1 vs_water_env();
			PixelShader = compile ps_2_0 PS_p0();
		}
	}

technique fallback { pass one { } }";
}


function init_mat_ffe_river()
{
	bmap_to_mipmap(mtl.skin1);
	bmap_to_mipmap(mtl.skin2);
	bmap_to_normals(mtl.skin1,my.riv_wav_height);

	vec_set(mtl.ambient_blue,vector(clamp((d3d_fogcolor1.blue*my.riv_fogcol_fac)+(my.riv_add_blue*clamp(sun_angle.tilt/30,0.2,1))+(lightning),0,255),clamp((d3d_fogcolor1.green*my.riv_fogcol_fac)+(my.riv_add_green*clamp(sun_angle.tilt/30,0.2,1))+(lightning),0,255),clamp((d3d_fogcolor1.red*my.riv_fogcol_fac)+(my.riv_add_red*clamp(sun_angle.tilt/30,0.2,1))+(lightning),0,255)));		
	
	mat_identity(mtl.matrix);

	mtl.matrix31 = floatd(my.riv_wav_speed_x*total_ticks,256);//u-speed
	mtl.matrix32 = floatd(my.riv_wav_speed_y*total_ticks,256);//v-speed

	mtl.matrix11 = floatv(my.riv_wav_scale/2); // waterbump_size
	mtl.matrix22 = floatv(my.riv_wav_scale); // waterbump_size	

	set(mtl,ENABLE_RENDER);
}

MATERIAL* mat_ffe_river = 
{
	skin1 = bmp_river_bump_ffe;
	skin2 = bmp_river_ffe;
	
	event = init_mat_ffe_river;

	effect = 
	"
	float4 mtlSkill1;

	texture mtlSkin1;
	texture mtlSkin2;
	texture mtlSkin3;//alpha in this texture indicates transparancy
	texture mtlSkin4;//dummy texture to mix-in material setup

	matrix matMtl;

	technique reflecting_water
	{    
		pass p0
		{
			Texture[1] = <mtlSkin1>;
			
			ColorArg1[1] = Texture; 
			ColorOp[1] = bumpenvmap;
			ColorArg2[1] = current;
			
			TextureTransformFlags[1] = Count2;
			TextureTransform[1] = <matMtl>;
			Texcoordindex[1]=1;
			
			
			Texture[2] = <mtlSkin2>;
			
			ColorArg1[2] = Texture; 
			ColorOp[2] = Add;
			ColorArg2[2] = Current;
			
			TextureTransformFlags[2] = count2;
			
			TextureTransform[2] = {
				3.0, 0.0, 0.0, 0.0,//u-scale of lake rgb texture CHANGE THIS TO YOUR NEEDS!
				0.0, 3.0, 0.0, 0.0,//v-scale of lake rgb texture CHANGE THIS TO YOUR NEEDS!
				0.0, 0.0, 0.0, 0.0,
				0.0, 0.0, 0.0, 0.0
			};
			
			texcoordindex[2]= 1;
			
			Texture[3] = <mtlSkin3>;// alpha in this texture makes entSkin1-texture transparent
			
			TexCoordIndex[3] = 1;
			
			
			ColorArg1[3] = Current;
			ColorOp[3] = modulate;
			AlphaOp[3] = Modulate;
			
			
			Texture[4] = <mtlSkin4>;
			
			TexCoordIndex[4] = 0;
			
			ColorArg1[4] = <mtlSkill1>;
			ColorOp[4] = Modulate2x;
			ColorArg2[4] = Current;
			
			alphablendenable = true;
			alphatestenable = false;//true;
			zenable = true;
			zwriteenable=true;
			
			CullMode=none;
			
		}
	}

technique fallback { pass p0 { } }";

}

var shore_fhandle_n;

//---------------------------------------------------------write tga
function shore_write8(var shore_byte) // write char
{
	file_asc_write(shore_fhandle_n,shore_byte);
}

function shore_write16(var shore_short) // write unsigned shore_short
{
	file_asc_write(shore_fhandle_n,shore_short&255);
	file_asc_write(shore_fhandle_n,(shore_short>>8)&255);
}

function write_shoremap_tga(STRING* shoremap_file_name)
{
	var i;
	var format;
	var pixel;
	var pixelalpha;
	VECTOR canvas_shoremap_size;
	VECTOR temp;

	canvas_shoremap_size.x=bmap_width(canvas_shoremap);
	canvas_shoremap_size.y=bmap_height(canvas_shoremap);
	format=bmap_lock(canvas_shoremap,0);

	shore_fhandle_n=file_open_write(shoremap_file_name);
	//------------------------------------write header
	shore_write8(0);
	shore_write8(0);
	shore_write8(2); // image type // 10 = RLE compressed tga, 2 = uncompressed tga
	shore_write16(0);
	shore_write16(0);
	shore_write8(0);
	shore_write16(0);
	shore_write16(0);
	shore_write16(canvas_shoremap_size.x); // width
	shore_write16(canvas_shoremap_size.y); // height
	shore_write8(24);//or 32 for alphachanel
	shore_write8(0);
	//------------------------------------write image data
	i=0;
	while(i<canvas_shoremap_size.x*canvas_shoremap_size.y)
	{
		pixel = pixel_for_bmap(canvas_shoremap,i%canvas_shoremap_size.x,(canvas_shoremap_size.y-1)-integer(i/canvas_shoremap_size.x));
		pixel_to_vec(temp,pixelalpha,format,pixel);
		shore_write8(temp.x); // b
		shore_write8(temp.y); // g
		shore_write8(temp.z); // r
		i+=1;
		//		if(i%max_loops == 0){wait(1);}
	}
	file_close(shore_fhandle_n);
	bmap_unlock(canvas_shoremap);
	
	reset(txt_wait_shore_gen,VISIBLE);
	txt_shore_finished.pos_x = screen_size.x/2;
	txt_shore_finished.pos_y = screen_size.y/2-20;
	set(txt_shore_finished,VISIBLE);
	wait(-4);
	reset(txt_shore_finished,VISIBLE);
}

VECTOR btemp;

function shore_get_xyz(var shore_px,var shore_py)
{
	VECTOR pixel_size;
	
	pixel_size.x=(my.max_x-my.min_x)/canvas_shoremap_size.x;
	pixel_size.y=(my.max_y-my.min_y)/canvas_shoremap_size.y;
	btemp.x=((my.x-my.min_x)-(pixel_size.x*shore_px))-pixel_size.x/2;
	btemp.y=((my.y-my.min_y)-(pixel_size.y*shore_py))-pixel_size.y/2;
	c_trace(vector(btemp.x,btemp.y,my.z+50000),vector(btemp.x,btemp.y,my.z-50000),IGNORE_SPRITES+IGNORE_MAPS);
	btemp.z=target.z;
}

function shoremap_gen(var shore_depth,var shore_smooth)
{
	var shore_px;
	var shore_py;
	var format;
	var pixel;
	var dist;

	canvas_shoremap=bmap_for_entity(my,1); // the second texture of the terrain is the shadowmap
	canvas_shoremap_size.x=bmap_width(canvas_shoremap);
	canvas_shoremap_size.y=bmap_height(canvas_shoremap);

	shore_py=0;
	while(shore_py<canvas_shoremap_size.y)
	{
		shore_px=0;
		while(shore_px<canvas_shoremap_size.x)
		{
			shore_get_xyz(shore_px,shore_py); // get the world coordinates of the pixel
			dist = c_trace(vector(btemp.x,btemp.y,btemp.z+1),vector(btemp.x,btemp.y,btemp.z-10000),IGNORE_ME+IGNORE_SPRITES); // trace from the sun to the pixel
			if(trace_hit && dist < shore_depth) // draw shadow pixel if there is no obstacle
			{
				format=bmap_lock(canvas_shoremap,0);
				pixel=pixel_for_vec(vector(0,clamp(255-((dist*shore_smooth)/(shore_depth/100))*2.55,0,255),255-(dist/(shore_depth/100))*2.55),0,format);
				pixel_to_bmap(canvas_shoremap,(canvas_shoremap_size.x-1)-shore_px,shore_py,pixel);
				bmap_unlock(canvas_shoremap);
			}
			
			shore_px+=1;
		}
		shore_py+=1;
		
		txt_wait_shore_gen.pos_x = screen_size.x/2;
		txt_wait_shore_gen.pos_y = screen_size.y/2-20;
		set(txt_wait_shore_gen,VISIBLE);
		
		wait(1); // without a wait after each line the loop could get too big if the shadow map is huge
	}
	
	str_cpy(lake_hlsl_shoremap_tempstr1,lake_hlsl_shoremap_str);
	str_for_num(lake_hlsl_shoremap_tempstr2,ent_lake.lake_id_number);
	str_cat(lake_hlsl_shoremap_tempstr1,lake_hlsl_shoremap_tempstr2);
	str_cat(lake_hlsl_shoremap_tempstr1,lake_hlsl_shoremap_filetype);
	
	write_shoremap_tga(lake_hlsl_shoremap_tempstr1);
}


//title:MystyMood Water Template
//image:loopix_logo.pcx
//action:act_river 
//skill1:riv_add_red 0.000
//help:riv tint red...0-255
//skill2:riv_add_green 0.000
//help:riv tint green...0-255
//skill3:riv_add_blue 0.000
//help:riv tint blue...0-255
// section:
//skill4:riv_fogcol_fac
//help:influence of fogcolor1 on water...0-1
//skill5:riv_alpha
//help:transparency of water
// section:
//skill6:riv_wav_speed_x
//help:wave-speed x
//skill7:riv_wav_speed_y
//help:wave-speed y
//skill8:riv_wav_scale
//help:scale of the wave bumpmap (wavesize)
//skill9:riv_wav_height
//help:height of the bumps (waves)
// section:
//skill10:riv_geowave_amp
//help:amplitude of geometrical wave-movement when set
//skill11:riv_geowave_sp
//help:speed of geometrical wave-movement when set
//section:
//skill12:riv_id_number 1.000
//help:this number should be integer and correspond to the skycube filename ending number...for cubic environmental reflection
//section:
//text:flag for enableing geometrical wave-movement
//flag1:riv_geowavemove
// section:
//text:flag for using the fixed function pipeline only
//flag3:riv_ffe_only
// section:
//text:flag for using realtime reflection
//flag4:riv_enable_rr
//uses:riv_add_red,riv_add_green,riv_add_blue,riv_fogcol_fac,riv_alpha,riv_wav_speed_x,riv_wav_speed_y,riv_wav_scale,riv_wav_height,riv_geowavemove,riv_geowave_amp,riv_geowave_sp,riv_shore_depth,riv_shore_smoothness,riv_shore_generation,riv_ffe_only,riv_enable_rr,riv_id_number
action act_river()
{
	var index;
	var counter;	
	var number_of_vertices;	
	VECTOR temp;
	
	ent_river = me;
	
	//	c_setminmax(me);
	
	set(my,PASSABLE,TRANSLUCENT);
	
	//UNCOMENT THIS PUSH IF YOU WANT TO SEED SHELLS AND UNDERWATER STUFF WITH SEED_IT!
	//	my.push = -1;
	
	//skill settings...defaults	
	if (my.riv_wav_speed_x) { my.skill41 = floatd(my.riv_wav_speed_x,256); }
	else { my.skill41 = floatd(0.01,256); }
	if (my.riv_wav_speed_y) { my.skill42 = floatd(my.riv_wav_speed_y,256); }
	else { my.skill42 = floatd(2.0,256); }
	if (my.riv_wav_height) { my.skill43 = floatv(my.riv_wav_height*0.5); }
	else { my.skill43 = floatv(0.5); }
	if (my.riv_wav_scale) { my.skill44 = floatv(my.riv_wav_scale/2); }
	else { my.skill44 = floatv(0.5); }
	
	if(d3d_shaderversion<2020 || is(my,riv_ffe_only)){
		if(!my.riv_wav_speed_x){my.riv_wav_speed_x = 0;}
		if(!my.riv_wav_speed_y){my.riv_wav_speed_y = 0.2;}
		if(!my.riv_wav_scale){my.riv_wav_scale = 1.0;}
		if(!my.riv_wav_height){my.riv_wav_height = 0.5;}
	}
	
	if(!my.riv_add_blue){my.riv_add_blue = 150;}
	if(!my.riv_add_green){my.riv_add_green = 150;}
	if(!my.riv_add_red){my.riv_add_red = 150;}
	if(!my.riv_fogcol_fac){my.riv_fogcol_fac = 0.5;}	
	if(!my.riv_alpha){my.riv_alpha = 95;}
	if(!my.riv_geowave_amp){my.riv_geowave_amp = 3;}
	if(!my.riv_geowave_sp){my.riv_geowave_sp = 3.2;}
	if(!my.riv_id_number){my.riv_id_number = 1;}
	
	
	if(d3d_shaderversion>=2020 && !is(my,riv_ffe_only)){
		
		ent_morphskin(my,river_hlsl_shoremap_string);
	}

	if(d3d_shaderversion>=2020 && !is(my,riv_ffe_only)){
		
		if(!is(my,riv_enable_rr))
		{
			my.material = mat_hlsl_river;
			
			str_cpy(reflect_cubemap_tempstr1,reflect_cubemap_str);
			str_for_num(reflect_cubemap_tempstr2,my.riv_id_number);
			str_cat(reflect_cubemap_tempstr1,reflect_cubemap_tempstr2);
			str_cat(reflect_cubemap_tempstr1,reflect_cubemap_filetype);
			
			mat_hlsl_river.skin2 = bmap_create(reflect_cubemap_tempstr1);
		}
		else
		{
			func_rr();
			my.material = mat_hlsl_river_rr;
		}	
		
	}
	else{
		if(!my.riv_alpha){my.riv_alpha = 80;}
		else{
			my.alpha = my.riv_alpha;
		}
		
		mat_ffe_river.skin3 = bmap_create(river_ffe_shoremap_string);
		
		my.material = mat_ffe_river;	
	}
	
	//	geometrical watermovement
	if(is(my,riv_geowavemove)){
		
		while(1){
			
			number_of_vertices = ent_vertices(my);
			//water_vertex_array[ent_vertices(my)];
			
			while (counter < number_of_vertices) 
			{
				water_vertex_array[counter] = random(360); // set random values in vertex_array
				counter += 1;
			} 
			index = 0;
			
			while (index < number_of_vertices) 
			{
				vec_for_mesh(temp, my, index); // store the vertex coordinates in temp
				temp.z = sin(counter + water_vertex_array[index]) * my.riv_geowave_amp/100; // change the z component
				vec_to_mesh(temp, my, index); // deform the terrain entity
				index += 1;
				
			}
			counter += my.riv_geowave_sp * time_step;
			
			wait(1);		
		}	
	}	
}



////river stream forces//////////////////////////////////////
//
//The drift model triangle can be duplicated/rotated/moved in WED. THIS IS NOT INCLUDED IN MystyMood!!!
//The triangles sharpest point indicates the drift direction.
//The size of the triangle (baselin to shapest point) indicates also the drift area.
//Eventhough it's a triangle, the drift area will be a square ("bounding-box" of triangle).
//
//In WED skill1 sets the drift_force. If flag1 is checked, the drift_force is 0.
//If skill1 is 0, the default drift_force is 0.09.
/////////////////////////////////////////////////////////////

function func_stream_drift()
{ 
	VECTOR temp;
	while(1)
	{
		ent_drift_dummy=me;
		
		if(!ent_drift_dummy.drift_force){ent_drift_dummy.drift_force=0.09;}//if skill1 is not set in WED, defualt drift_force is 0.09
		if(is(ent_drift_dummy,no_drift_force)){ent_drift_dummy.drift_force=0;}
		
		if(vec_dist(ent_drift_dummy.x,player.x)<(200*ent_drift_dummy.scale_x))//200 is the original size of the drift model triangle "bounding-box" in MED
		{
			vec_for_angle(temp,ent_drift_dummy.pan);
			vec_scale(temp, ent_drift_dummy.drift_force); //the speed...can be set in WED skill1
			vec_set(player.player_abs_dist_force,temp);
		}
		wait(1);
	}	
}

//title:MystyMood Water Template
//image:loopix_logo.pcx
//action:act_river_streaming 
//skill1:drift_force 0.130
//help:drift force of water that influences the abs_dist(saved in skill50) e.g. of a player entity
// section:
//text:flag for disableing drift force
//flag1:no_drift_force
//uses: drift_force, no_drift_force
action act_river_streaming()
{
	while(ent_terrain==0){wait(1);}

	ent_drift_dummy = me;

	set(my,PASSABLE|INVISIBLE);

	my.z = ent_river.z;

	func_stream_drift();
}


function init_mat_ffe_lake()
{
	bmap_to_mipmap(mtl.skin1);
	bmap_to_mipmap(mtl.skin2);
	bmap_to_normals(mtl.skin1,ent_lake.lake_wav_height);

	vec_set(mtl.ambient_blue,vector(clamp((d3d_fogcolor1.blue*ent_lake.lake_fogcol_fac)+(ent_lake.lake_add_blue*clamp(sun_angle.tilt/30,0.2,1))+(lightning),0,255),clamp((d3d_fogcolor1.green*ent_lake.lake_fogcol_fac)+(ent_lake.lake_add_green*clamp(sun_angle.tilt/30,0.2,1))+(lightning),0,255),clamp((d3d_fogcolor1.red*ent_lake.lake_fogcol_fac)+(ent_lake.lake_add_red*clamp(sun_angle.tilt/30,0.2,1))+(lightning),0,255)));		
	
	mat_identity(mtl.matrix);

	mtl.matrix31 = floatd(ent_lake.lake_wav_speed_x*10*total_ticks,256);//u-speed
	mtl.matrix32 = floatd(ent_lake.lake_wav_speed_y*10*total_ticks,256);//v-speed

	mtl.matrix11 = floatv(ent_lake.lake_wav_scale); // waterbump_size
	mtl.matrix22 = floatv(ent_lake.lake_wav_scale); // waterbump_size

	set(mtl,ENABLE_RENDER);
}


MATERIAL* mat_ffe_lake =
{
	skin1 = bmp_lake_bump_ffe;
	skin2 = bmp_lake_ffe;
	
	event = init_mat_ffe_lake;

	effect = 
	"
	float4 mtlSkill1;

	texture mtlSkin1;
	texture mtlSkin2;
	texture mtlSkin3;//alpha in this texture indicates transparancy
	texture mtlSkin4;//dummy texture to mix-in material setup

	matrix matMtl;

	technique reflecting_water
	{    
		pass p0
		{
			Texture[1] = <mtlSkin1>;
			
			ColorArg1[1] = Texture; 
			ColorOp[1] = bumpenvmap;
			ColorArg2[1] = current;
			
			TextureTransformFlags[1] = Count2;
			TextureTransform[1] = <matMtl>;
			Texcoordindex[1]=1;
			
			
			Texture[2] = <mtlSkin2>;
			
			ColorArg1[2] = Texture; 
			ColorOp[2] = Add;
			ColorArg2[2] = Current;
			
			TextureTransformFlags[2] = count2;
			
			TextureTransform[2] = {
				15.0, 0.0, 0.0, 0.0,//u-scale of lake rgb texture CHANGE THIS TO YOUR NEEDS!
				0.0, 15.0, 0.0, 0.0,//v-scale of lake rgb texture CHANGE THIS TO YOUR NEEDS!
				0.0, 0.0, 0.0, 0.0,
				0.0, 0.0, 0.0, 0.0
			};
			
			texcoordindex[2]= 1;
			
			Texture[3] = <mtlSkin3>;
			
			TexCoordIndex[3] = 1;
			
			
			ColorArg1[3] = Current;
			ColorOp[3] = modulate;
			AlphaOp[3] = Modulate;
			
			
			Texture[4] = <mtlSkin4>;
			
			TexCoordIndex[4] = 0;
			
			ColorArg1[4] = <mtlSkill1>;
			ColorOp[4] = Modulate2x;
			ColorArg2[4] = Current;
			
			AlphaBlendEnable = True;
			ZEnable = True;
			ZWriteEnable=True;
			CullMode=none;
			
		}
	}

technique fallback { pass p0 { } }";

}

BMAP* bmap_mirrortarget;

function func_rr()
{	
	if(bmap_mirrortarget) { return; }

	bmap_mirrortarget = bmap_createblack(512,512,24);
	
	mat_hlsl_lake_rr.skin2 = bmap_mirrortarget;//create mirrortarget bitmap for lake entity
	mat_hlsl_river_rr.skin2 = bmap_mirrortarget;//create mirrortarget bitmap for river entity
	
	view_rr.bmap = bmap_mirrortarget;
	view_rr.size_x = bmap_width(view_rr.bmap);
	view_rr.size_y = bmap_height(view_rr.bmap);

	vec_set(view_rr.portal_x,vector(0,0,my.z + my.max_z)); // at top entity position
	vec_set(view_rr.pnormal_x,vector(0,0,1.0));	// reflect upwards
	set(view_rr,NOSHADOW|NOCULL|PORTALCLIP|NOPARTICLE);
	//view_rr.noshader = on;
	
	while((my != 0) && (bmap_mirrortarget != 0))
	{
		proc_mode = PROC_LATE;	// camera must be moved and mtlfx_mirrorvisible set before
		set(view_rr,VISIBLE);
		//		view_rr.aspect = screen_size.x/screen_size.y; // screen aspect, independent of render target
		//		view_rr.arc    = camera.arc;
		//		view_rr.fog_start = camera.fog_start;
		//		view_rr.fog_end   = camera.fog_end;
		//		view_rr.clip_far  = camera.clip_far;// * 0.5;
		//		view_rr.clip_near = camera.clip_near;// * 2;
		//		view_rr.x 	   = camera.x;
		//		view_rr.y 	   = camera.y;
		//		//		view_rr.z = 2*my.z-camera.z;
		//		view_rr.z 	   = 2*view_rr.portal_z-camera.z;//+2500;	// move the camera at its mirror position
		//		view_rr.pan    = camera.pan;
		//		view_rr.tilt   = -camera.tilt;	// flip the vertical camera angle
		//		view_rr.roll   = -camera.roll;

		if(camera.z > my.z){
			
			view_rr.aspect = screen_size.x/screen_size.y; // screen aspect, independent of render target
			view_rr.arc    = camera.arc;
			view_rr.fog_start = camera.fog_start;
			view_rr.fog_end   = camera.fog_end;
			view_rr.clip_far  = camera.clip_far;// * 0.5;
			view_rr.clip_near = camera.clip_near;// * 2;
			view_rr.x 	   = camera.x;
			view_rr.y 	   = camera.y;
			//		view_rr.z = 2*my.z-camera.z;
			view_rr.z 	   = 2*view_rr.portal_z-camera.z;//+2500;	// move the camera at its mirror position
			view_rr.pan    = camera.pan;
			view_rr.tilt   = -camera.tilt;	// flip the vertical camera angle
			view_rr.roll   = -camera.roll;
		}
		else{
			view_rr.aspect = -screen_size.x/screen_size.y; // screen aspect, independent of render target
			view_rr.arc    = camera.arc;
			view_rr.fog_start = camera.fog_start;
			view_rr.fog_end   = camera.fog_end;
			view_rr.clip_far  = camera.clip_far;// * 0.5;
			view_rr.clip_near = camera.clip_near;// * 2;
			view_rr.x 	   = camera.x;
			view_rr.y 	   = camera.y;
			//		view_rr.z = 2*my.z-camera.z;
			view_rr.z 	   = 2*view_rr.portal_z-camera.z;//+2500;	// move the camera at its mirror position
			view_rr.pan    = camera.pan;
			view_rr.tilt   = camera.tilt;	// flip the vertical camera angle
			view_rr.roll   = camera.roll;
		}
		
		
		wait(1);
	}
}

//title:MystyMood Water Template
//image:loopix_logo.pcx
//action:act_lake 
//skill1:lake_add_red 0.000
//help:lake tint red...0-255
//skill2:lake_add_green 0.000
//help:lake tint green...0-255
//skill3:lake_add_blue 0.000
//help:lake tint blue...0-255
// section:
//skill4:lake_fogcol_fac 0.500
//help:influence of fogcolor1 on water...0-1
//skill5:lake_alpha 95.000
//help:transparency of water
// section:
//skill6:lake_wav_speed_x
//help:wave-speed x
//skill7:lake_wav_speed_y
//help:wave-speed y
//skill8:lake_wav_scale
//help:scale of the wave bumpmap (wavesize)
//skill9:lake_wav_height
//help:height of the bumps (waves)
// section:
//skill10:lake_shore_depth
//help:affects range of the shore-break
//skill11:lake_shore_smoothness
//help:affects smoothness of the shore-break range
// section:
//skill12:lake_geowave_amp 0.200
//help:amplitude of geometrical wave-movement when set
//skill13:lake_geowave_sp 5
//help:speed of geometrical wave-movement when set
// section:
//skill14:lake_id_number 1.000
//help:must be integer...defines the shoremap and the reflection cubemap picture file (should correspond to their end number, eg. _1) used for this waterplane
//section:
//text:flag for enableing geometrical wave-movement
//flag1:lake_geowavemove
// section:
//text:check this flag to switch to shore-break generation mode...uncheck when done
//flag3:lake_shore_gen
//section:
//text:flag for using the fixed function pipeline only
//flag4:lake_ffe_only
//section:
//text:flag for using realtimereflections
//flag5:lake_enable_rr
//uses:lake_add_red,lake_add_green,lake_add_blue,lake_fogcol_fac,lake_wav_speed_x,lake_wav_speed_y,lake_wav_scale,lake_wav_height,lake_geowavemove,lake_geowave_amp,lake_geowave_sp,lake_shore_depth,lake_shore_smoothness,lake_shore_gen,lake_ffe_only,lake_enable_rr,lake_id_number
action act_lake()
{
	var index;
	var counter;	
	var number_of_vertices;	
	VECTOR temp;
	
	ent_lake = me;
	
	c_setminmax(me);
	
	set(my,PASSABLE|TRANSLUCENT);
	
	//UNCOMENT THIS PUSH IF YOU WANT TO SEED SHELLS AND UNDERWATER STUFF WITH SEED_IT!
	//	my.push = -1;
	
	//skill settings...defaults	
	if (my.lake_wav_speed_x) { my.skill41 = floatd(my.lake_wav_speed_x,256); }
	else { my.skill41 = floatd(0.01,256); }
	if (my.lake_wav_speed_y) { my.skill42 = floatd(my.lake_wav_speed_y,256); }
	else { my.skill42 = floatd(0.0,256); }
	if (my.lake_wav_height) { my.skill43 = floatv(my.lake_wav_height*0.5); }
	else { my.skill43 = floatv(0.5); }
	if (my.lake_wav_scale) { my.skill44 = floatv(my.lake_wav_scale*3); }
	else { my.skill44 = floatv(5); }
	
	if(d3d_shaderversion<2020 || is(my,lake_ffe_only)){
		if (my.lake_wav_speed_x){my.lake_wav_speed_x = 0;}
		if (!my.lake_wav_speed_y){my.lake_wav_speed_y = -0.02;}
		if (!my.lake_wav_scale){my.lake_wav_scale = 10;}
		if (!my.lake_wav_height){my.lake_wav_height = 0.5;}
	}
	
	if(!my.lake_add_blue){my.lake_add_blue = 150;}
	if(!my.lake_add_green){my.lake_add_green = 150;}
	if(!my.lake_add_red){my.lake_add_red = 150;}
	if(!my.lake_fogcol_fac){my.lake_fogcol_fac = 0.5;}	
	if(!my.lake_alpha){my.lake_alpha = 95;}
	if(!my.lake_geowave_amp){my.lake_geowave_amp = 0.13;}
	if(!my.lake_geowave_sp){my.lake_geowave_sp = 3.2;}
	if(!my.lake_shore_depth){my.lake_shore_depth = 30;}
	if(!my.lake_shore_smoothness){my.lake_shore_smoothness = 5;}
	if(!my.lake_id_number){my.lake_id_number = 1;}

	if(is(my,lake_shore_gen))
	{
		txt_press_shore_gen.pos_x = screen_size.x/2;
		txt_press_shore_gen.pos_y = screen_size.y/2-20;
		
		set(txt_press_shore_gen,VISIBLE);
		
		while(key_h == 0){wait(1);}
		
		shoremap_gen(my.lake_shore_depth,my.lake_shore_smoothness);
		
		reset(txt_press_shore_gen,VISIBLE);	
	}
	else{
		
		str_cpy(lake_hlsl_shoremap_tempstr1,lake_hlsl_shoremap_str);
		str_for_num(lake_hlsl_shoremap_tempstr2,my.lake_id_number);
		str_cat(lake_hlsl_shoremap_tempstr1,lake_hlsl_shoremap_tempstr2);
		str_cat(lake_hlsl_shoremap_tempstr1,lake_hlsl_shoremap_filetype);
		
		if(d3d_shaderversion>=2020 && !is(my,lake_ffe_only)){
			
			ent_morphskin(my,lake_hlsl_shoremap_tempstr1);
			
		}
	}

	if(d3d_shaderversion>=2020 && !is(my,lake_ffe_only)){
		
		if(!is(my,lake_enable_rr))
		{
			my.material = mat_hlsl_lake;
			
			str_cpy(reflect_cubemap_tempstr1,reflect_cubemap_str);
			str_for_num(reflect_cubemap_tempstr2,my.lake_id_number);
			str_cat(reflect_cubemap_tempstr1,reflect_cubemap_tempstr2);
			str_cat(reflect_cubemap_tempstr1,reflect_cubemap_filetype);
			
			mat_hlsl_lake.skin2 = bmap_create(reflect_cubemap_tempstr1);
		}
		else
		{
			func_rr();
			my.material = mat_hlsl_lake_rr;
		}	
	}
	else{
		if(!my.lake_alpha){my.lake_alpha = 80;}
		else{
			my.alpha = my.lake_alpha;
		}
		
		str_cpy(lake_ffe_shoremap_tempstr1,lake_ffe_shoremap_str);
		str_for_num(lake_ffe_shoremap_tempstr2,my.lake_id_number);
		str_cat(lake_ffe_shoremap_tempstr1,lake_ffe_shoremap_tempstr2);
		str_cat(lake_ffe_shoremap_tempstr1,lake_ffe_shoremap_filetype);
		
		mat_ffe_lake.skin3 = bmap_create(lake_ffe_shoremap_tempstr1);
		
		my.material = mat_ffe_lake;
	}
	
	//	geometrical watermovement
	if(is(my,lake_geowavemove)){
		
		while(1){
			
			number_of_vertices = ent_vertices(my);
			//water_vertex_array[ent_vertices(my)];
			
			while (counter < number_of_vertices) 
			{
				water_vertex_array[counter] = random(360); // set random values in vertex_array
				counter += 1;
			} 
			index = 0;
			
			while (index < number_of_vertices) 
			{
				vec_for_mesh(temp, my, index); // store the vertex coordinates in temp
				temp.z = sin(counter + water_vertex_array[index]) * my.lake_geowave_amp/200; // change the z component
				vec_to_mesh(temp, my, index); // deform the terrain entity
				index += 1;
				
			}
			counter += my.lake_geowave_sp * time_step;
			
			wait(1);		
		}	
	}	
}



//dummy material for some mtl settings (fogcolor influence) used in particle-fall and bott-spray
MATERIAL* mat_particle_fall = 
{
	effect = 
	"
	extern texture entSkin1;

	technique alphaTestMaterial
	{
		pass p0{
			
			zEnable = true;
			zWriteEnable=true;
			AlphaBlendEnable=false;
			zFunc=less;
			cullMode=none;
			
		}
	}

	technique fallback
	{
		pass p0{
		Texture[0]=<entSkin1>;}
	}
	";
}

function init_mat_ffe_waterfall()
{
	bmap_to_mipmap(mtl.skin1);
	
	vec_set(mtl.ambient_blue,vector(clamp((d3d_fogcolor1.blue*ent_waterfall.fall_fogcol_fac)+(ent_waterfall.fall_add_blue*clamp(sun_angle.tilt/30,0.7,1))+(lightning),100,255),clamp((d3d_fogcolor1.green*ent_waterfall.fall_fogcol_fac)+(ent_waterfall.fall_add_green*clamp(sun_angle.tilt/30,0.7,1))+(lightning),100,255),clamp((d3d_fogcolor1.red*ent_waterfall.fall_fogcol_fac)+(ent_waterfall.fall_add_red*clamp(sun_angle.tilt/30,0.7,1))+(lightning),0,255)));		
	
	mat_identity(mtl.matrix);

	//	mtl.matrix31 = floatd(ent_waterfall.fall_speed_x*total_ticks,256);//u_speed
	mtl.matrix32 = floatd(ent_waterfall.fall_speed_y*total_ticks,256);//v_speed
	
	set(mtl,ENABLE_RENDER);
}


MATERIAL* mat_ffe_waterfall = 
{
	skin1 = bmp_waterfall_alpha;

	event = init_mat_ffe_waterfall;

	effect = "

	float4 mtlSkill1;

	texture entSkin1;
	texture mtlSkin1;//alpha in this texture indicates transparancy
	texture mtlSkin2;//dummy texture to mix-in material setup

	matrix matMtl;

	technique waterfall
	{    
		pass p0
		{
			Texture[0] = <entSkin1>;
			
			TexCoordIndex[0] = 1;
			TextureTransformFlags[0] = Count2;
			TextureTransform[0] = <matMtl>;
			
			ColorArg1[0] = Texture;
			ColorOp[0] = modulate;
			
			
			Texture[1] = <mtlSkin1>;
			
			TexCoordIndex[1] = 1;
			
			ColorArg1[1] = Current;
			ColorOp[1] = ModulateAlpha_AddColor;
			AlphaOp[1] = Modulate;
			
			
			Texture[2] = <mtlSkin2>;
			
			TexCoordIndex[2] = 0;
			
			ColorArg1[2] = <mtlSkill1>;//Current;// Get current texture (0)
			ColorOp[2] = Modulate2x;//ModulateAlpha_AddColor;//and add alpha to indicate transparency
			ColorArg2[2] = Current;
			
			alphablendenable = true;
			alphatestenable = false;
			zenable = true;
			zwriteenable = true;
			
			cullmode = none;
		}
	}

technique fallback { pass p0 { } }";

}

/////////////////////////////////////bott PARTICLE-ACTION

function init_prefunc_bottom_spray(PARTICLE *p)
{
if(p.size > 0) { p.size -= -3 *time_step; }else{p.lifespan = 0; }
	p.alpha -= ent_waterfall.bott_spray_fadetime*time_step;//4.5 *time_step;
	if(p.alpha < 0 || p.z < (ent_waterfall.z)) { p.alpha = 0; p.lifespan = 0; }
}

function prefunc_bottom_spray(PARTICLE *p)
{
	mat_particle_fall.ambient_blue=clamp((d3d_fogcolor1.blue*ent_waterfall.fall_fogcol_fac)+(ent_waterfall.fall_add_blue*clamp(sun_angle.tilt/30,0.1,1)),0,255);
	mat_particle_fall.ambient_green=clamp((d3d_fogcolor1.green*ent_waterfall.fall_fogcol_fac)+(ent_waterfall.fall_add_green*clamp(sun_angle.tilt/30,0.1,1)),0,255);
	mat_particle_fall.ambient_red=clamp((d3d_fogcolor1.red*ent_waterfall.fall_fogcol_fac)+(ent_waterfall.fall_add_red*clamp(sun_angle.tilt/30,0.1,1)),0,255);

	p.blue=mat_particle_fall.ambient_blue;
	p.green=mat_particle_fall.ambient_green;
	p.red=mat_particle_fall.ambient_red;

	p.bmap = bmp_bott_spray;
	p.vel_x = p.vel_x*random(1);
	p.vel_y = p.vel_y*random(1);
	p.vel_z = 4.5 ;
	p.size = 0.5;
	set(p,TRANSLUCENT);
	p.alpha = ent_waterfall.bott_spray_alpha;
	p.gravity = 0.4 ;
	reset(p,STREAK);
	if(is(ent_waterfall,bott_spray_bright)){
		set(p,BRIGHT);
	}
	else{
		reset(p,BRIGHT);
	}
	reset(p,BEAM);
	set(p,MOVE);

	p.event = init_prefunc_bottom_spray;
}

function func_bottom_spray(var Vertex,var PartZahl,var PartSpeed)
{
	VECTOR temp3;
	VECTOR temp4;
	while(1)
	{
		vec_for_vertex(temp3,my,Vertex);
		vec_for_normal(temp4,my,Vertex);
		
		vec_scale(temp4,random(PartSpeed));  //To change the speed
		effect(prefunc_bottom_spray,1,temp3,temp4);
		
		wait(-PartZahl);
	}
}


function init_prefunc_particle_fall(PARTICLE *p)
{
	if(p.size < 50) { p.size += 1.6 *time_step; }
	p.alpha -= ent_waterfall.p_fall_fadetime*time_step;//1.0
	if(p.alpha < 0 || p.z < ent_waterfall.z) { p.alpha = 0; p.lifespan = 0; }
}

function prefunc_particle_fall(PARTICLE *p)
{	
	mat_particle_fall.ambient_blue=clamp((d3d_fogcolor1.blue*ent_waterfall.fall_fogcol_fac)+(ent_waterfall.fall_add_blue*clamp(sun_angle.tilt/30,0.1,1)),0,255);
	mat_particle_fall.ambient_green=clamp((d3d_fogcolor1.green*ent_waterfall.fall_fogcol_fac)+(ent_waterfall.fall_add_green*clamp(sun_angle.tilt/30,0.1,1)),0,255);
	mat_particle_fall.ambient_red=clamp((d3d_fogcolor1.red*ent_waterfall.fall_fogcol_fac)+(ent_waterfall.fall_add_red*clamp(sun_angle.tilt/30,0.1,1)),0,255);

	p.blue=mat_particle_fall.ambient_blue;
	p.green=mat_particle_fall.ambient_green;
	p.red=mat_particle_fall.ambient_red;

	p.bmap = bmp_fall_spray;
	p.size = 10;
	set(p,TRANSLUCENT);
	p.alpha = 20;
	p.gravity = 0.2 ;
	reset(p,STREAK);
	if(is(ent_waterfall,bott_spray_bright)){
		set(p,BRIGHT);
	}
	else{
		reset(p,BRIGHT);
	}
	reset(p,BEAM);
	set(p,MOVE);
	
	p.event = init_prefunc_particle_fall;
}

function func_particle_fall(var Vertexy,var PartZahly,var Vel_x)
{
	VECTOR temp;
	while(1)
	{
		vec_for_vertex(temp,my,Vertexy);
		
		my.pan = ent_waterfall.pan;
		
		effect(prefunc_particle_fall,1,temp,vector(sin(my.pan+90)*Vel_x+(random(0.2)),-cos(my.pan+90)*Vel_x+(random(0.2)),random(0.2)));
		
		wait(-(PartZahly/2+PartZahly/4)+random(PartZahly/4));
	}
}



//title:MystyMood Water Template
//image:loopix_logo.pcx
//action:act_waterfall 
//skill1:fall_add_red 
//help:fall tint red...0-255
//skill2:fall_add_green
//help:fall tint green...0-255
//skill3:fall_add_blue 
//help:fall tint blue...0-255
// section:
//skill4:fall_fogcol_fac
//help:influence of fogcolor1 on fall...0-1
//skill5:fall_alpha 
//help:transparency of water
// section:
//skill6:fall_speed_y
//help:speed of fall-flow
//skill7:fall_scale_x 
//help:width of fall
//skill8:fall_scale_z 
//help:height of fall
// section:
//skill9:bott_spray_alpha 
//help:transparency of bottom spray
//skill10:bott_spray_speed 
//help:speed of bottom spray
//skill11:bott_spray_fadetime 
//help:particle fade-time
//skill12:bott_spray_dens 
//help:amount of bottom spray particles
// section:
//text:this section only applies when particle fall is enabled
//skill13:p_fall_jet_force 
//help:jet force of particle-fall
//skill14:p_fall_dens 
//help:amount of particle-fall particles
//skill15:p_fall_fadetime 
//help:fade-time of particle-fall particles
// section:
//text:flag for enableing particle-fall
//flag1:particle_fall 
// section:
//text:bright flag of fall
//flag3:fall_bright
// section:
//text:bright flag of bottom spray
//flag4:bott_spray_bright 
//uses: fall_add_red,fall_add_green,fall_add_blue,fall_fogcol_fac,fall_speed_x,fall_speed_y,fall_alpha,bott_spray_alpha,bott_spray_dens,bott_spray_fadetime,bott_spray_speed,p_fall_fadetime,fall_scale_x,fall_scale_z,particle_fall,bott_spray_bright,fall_bright,p_fall_dens,p_fall_jet_force
action act_waterfall()
{
	ent_waterfall=me;

	set(my,TRANSLUCENT,PASSABLE);
	
	if(!my.fall_alpha){my.fall_alpha = 70;}
	if(!my.fall_fogcol_fac){my.fall_fogcol_fac = 0.2;}
	if(!my.fall_speed_y){my.fall_speed_y = -7;}
	if(!my.fall_scale_x){my.fall_scale_x = 1;}
	if(!my.fall_scale_z){my.fall_scale_z = 1;}
	
	if(!my.fall_add_blue){my.fall_add_blue = 200;}
	if(!my.fall_add_green){my.fall_add_green = 200;}
	if(!my.fall_add_red){my.fall_add_red = 200;}
	if(!my.bott_spray_alpha){my.bott_spray_alpha = 60;}
	if(!my.bott_spray_speed){my.bott_spray_speed = 2;}
	if(!my.bott_spray_fadetime){my.bott_spray_fadetime = 3;}
	if(!my.bott_spray_dens){my.bott_spray_dens = 0.1;}
	
	if(!my.p_fall_jet_force){my.p_fall_jet_force = 1.4;}
	if(!my.p_fall_dens){my.p_fall_dens = 0.3;}
	if(!my.p_fall_fadetime){my.p_fall_fadetime = 0.1;}

	my.scale_y=my.fall_scale_x;
	my.scale_z=my.fall_scale_z;
	
	

	if(is(my,fall_bright)){
		set(my,BRIGHT);
	}
	else{
		reset(my,BRIGHT);
	}

	func_bottom_spray(7,my.bott_spray_dens,my.bott_spray_speed);
	func_bottom_spray(5,my.bott_spray_dens,my.bott_spray_speed);
	func_bottom_spray(1,my.bott_spray_dens,my.bott_spray_speed);
	func_bottom_spray(9,my.bott_spray_dens,my.bott_spray_speed);
	func_bottom_spray(11,my.bott_spray_dens,my.bott_spray_speed);	

	if(is(my,particle_fall)){
		set(my,INVISIBLE);
		
		func_particle_fall(53,my.p_fall_dens,my.p_fall_jet_force);
		
	}
	else{
		reset(my,INVISIBLE);
		
		my.material = mat_ffe_waterfall;	
	}
}
