#define PRAGMA_PATH "scripts"
#define PRAGMA_PATH "models"
#define PRAGMA_PATH "textures"

// Included files
#include <acknex.h>
#include <default.c>
#include "mystymood.c"


/////////////////////////////////////////////////////////////////
// Filename of the starting level.
STRING* level_str = "mystymood_demo.wmb"; // give file names in angular brackets

//var d3d_shaderversion = 0000;//uncoment for testing shader-fallback

BMAP* bmp_mystymood_logo = "mystymood_logo.jpg";

FONT* arial_font = "Arial#25b";
FONT* arial_font_small = "Arial#15b";

PANEL* splash1 =
{
	bmap = bmp_mystymood_logo;
	flags = TRANSLUCENT;
	alpha = 100;
}

void splash_on()
{
	splash1.pos_x = screen_size.x/2 - bmap_width(bmp_mystymood_logo)/2;
	splash1.pos_y = screen_size.y/2 - bmap_height(bmp_mystymood_logo)/2;
	set(splash1,VISIBLE);
}

void splash_fade_out()
{
	while(1)
	{	
		if(splash1.alpha>0)
		{
			splash1.alpha -= 8*time_step;
			if(splash1.alpha == 1)
			{
				reset(splash1,VISIBLE);
				bmap_purge(bmp_mystymood_logo);
				
				return;
			}
		}	
		wait(1);	
	}	
}

void main()
{	
	video_mode = 7; // 7= 800x600
   video_depth = 32;
   video_screen = 1; // 1= fullscreen
   fps_max = 60;
   time_smooth = 0.99;
   clip_size = 0;
   //var max_entities = 5000;
   terrain_chunk = 64;//I got fps problems using 32??
	
	wait(1);
	splash_on();
	level_load("mystymood_demo.wmb");
	wait(3);
	wait(-1);
	splash_fade_out();
	vec_set(d3d_lodfactor,vector(20,30,60));
	def_moveset();
}

//for testing!
action free_camera()
{
	//	c_setminmax(my);

	VECTOR camera_force;
	set(my,INVISIBLE|POLYGON);
//	set(my,PASSABLE);

	camera_force.z = 0;
	vec_set(camera.x,my.x);
	vec_set(camera.pan,my.pan);

	while(1)
	{
		camera_force.x = (key_w - key_s)*10*time_step;
		camera_force.y = (key_a - key_d)*10*time_step;
		vec_add(my.pan,vector(mouse_force.x*(-7)*time_step,mouse_force.y*7*time_step,0));
		
		c_move(my,camera_force,nullvector,GLIDE+IGNORE_PASSABLE+IGNORE_PASSENTS+IGNORE_PUSH);
		vec_set(camera.x,vector(my.x,my.y,my.z+15));
		vec_set(camera.pan,my.pan);
		
		wait(1);
	}
}
